#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_Icon=ClipSpirit-Maj.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Module de Mise A Jour des versions
#AutoIt3Wrapper_Res_Description=ClipSpirit - L'esprit de votre presse-papier
#AutoIt3Wrapper_Res_Fileversion=1.2.0.10
#AutoIt3Wrapper_Res_LegalCopyright=By Ahbadiane
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ---------------------------------------------------------------------------

	ClipSpirit-Maj - Gestion des Mises A Jour des versions
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Janvier 2011 - Septembre 2011

	BUG & Evolutions : A placer dans ClipSpirit.au3

#ce ---------------------------------------------------------------------------

#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
#include "ClipSpiritLib.au3"
#include "ClipSpiritDB.au3"


AutoItSetOption("MustDeclareVars", 1)
Opt("WinTitleMatchMode", 3) ;1=start, 2=subStr, 3=exact, 4=advanced, -1 to -4=Nocase

; Titre de la fentre
Global $sFenetreTitre = $scAppliTitreGeneral & " - Mise  jour des versions  v" & _NumVerCourt($scVersion)
If Not @Compiled Then $sFenetreTitre &= " Test"
$sFenetreTitre &= " " & $scAuteur


;----- Base de donnes --------------------------------------------------------
Global $dVersionDB = DbOuvrir($scProgMAJ)
If $dVersionDB = "" Then Exit


;----- Variables globales -----------------------------------------------------
Global $sProgAppelant
Global $bMAjOk = False

;----- Une seule instance -----------------------------------------------------
If _Singleton($sFenetreTitre,1) = 0 Then
	MsgBox(4144, $scMsgErreur, "L'application de mise  jour des versions est dj lance !")
	Exit
EndIf


;----- Interface --------------------------------------------------------------
#Region ### START Koda GUI section ### Form=ClipSpirit-Maj.kxf
Global $FormClipSpiritMAJ = GUICreate("~Titre~", 434, 106, -1, -1, BitOR($WS_CAPTION,$WS_POPUP,$WS_BORDER,$WS_CLIPSIBLINGS), BitOR($WS_EX_ACCEPTFILES,$WS_EX_WINDOWEDGE))
Global $Label1 = GUICtrlCreateLabel("", 2, 14, 429, 17, $SS_CENTER)
Global $Label2 = GUICtrlCreateLabel("", 2, 45, 429, 17, $SS_CENTER)
Global $LabelErreur = GUICtrlCreateLabel("", 2, 79, 374, 17, $SS_CENTER)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
GUICtrlSetColor(-1, 0xFF0000)
Global $ButtonOK = GUICtrlCreateButton("OK", 377, 75, 50, 25, $WS_GROUP)
GUICtrlSetState(-1, $GUI_HIDE)
#EndRegion ### END Koda GUI section ###


;----- Prparation de l'interface ---------------------------------------------

WinSetTitle("~Titre~", "", $sFenetreTitre)
GUISetState(@SW_SHOW, $FormClipSpiritMAJ)
WinSetOnTop($sFenetreTitre, "", 1)
GUICtrlSetData($Label1, "Mise  jour  partir de la version " & $dVersionDB)
If $CmdLine[0] >= 1 Then $sProgAppelant = $CmdLine[1]

;----- Partie principale ------------------------------------------------------
Switch $dVersionDB
	Case 1.0
		$bMAjOk = Maj_V1_0()
	Case 1.1
		; rien d'autre  faire entre 1.1 et 1.2 que la maj de la version
		$bMAjOk = MiseAJourChampVersion(1.2)
	Case 1.2
		MessageErreur("Il n'y a rien  mettre  jour !")
	Case Else
		MessageErreur("La mise  jour  partir de la version " & $dVersionDB & " n'est pas prvue !")
EndSwitch

;----- Optimisation de la base ------------------------------------------------
DbVacuum($FormClipSpiritMAJ, False)

;----- Fermeture de la base de donnes ----------------------------------------
_SQLite_Close($hDbPrp)
_SQLite_Shutdown()

;----- Messsage de fin OK -----------------------------------------------------
GUICtrlSetData($Label2, "Mise  jour russie")
GUICtrlSetData($LabelErreur, "")
GUICtrlSetState($ButtonOK, $GUI_SHOW)
While 1
	If GUIGetMsg() = $ButtonOK Then ExitLoop
	Sleep(10)
WEnd

;----- Lancement du programme appelant ----------------------------------------
If $sProgAppelant <> "" Then Run(@ScriptDir & "\" & $sProgAppelant)

;----- Sortie de l'application ------------------------------------------------
Exit


; ========== Fonctions principales ===============================================================


Func Maj_V1_0()
	Local $hQuery, $sData, $iCompteur, $iRefSynchro, $sDateAvant, $sDateClassement = "2010-01-01 01:01:01"
	;
	;---- Table Texte : Changement de structure ---------------------------------------------------
	GUICtrlSetData($Label2, "Changement de structure de la Table Texte")
	If _SQLite_Exec($hDbPrp, "ALTER TABLE Texte RENAME TO TexteOld;") <> $SQLITE_OK Then MessageErreur("Erreur : ALTER TABLE Texte RENAME TO TexteOld")
	If _SQLite_Exec($hDbPrp, "CREATE TABLE Texte (PrpText TEXT, PrpTitre TEXT, PrpEstFavoris BOOLEAN DEFAULT (0), PrpProvenance TEXT, PrpCommentaire TEXT, PrpPlus TEXT, PrpDateCreation TIMESTAMP, PrpDateModification TIMESTAMP, PrpDateUtilisation TIMESTAMP, PrpDateClassement TIMESTAMP NOT NULL, PrpRefSynchro INTEGER NOT NULL, CONSTRAINT [] PRIMARY KEY (PrpDateClassement, PrpRefSynchro));") _
									<> $SQLITE_OK Then MessageErreur("Erreur : CREATE TABLE Texte")
	If _SQLite_Exec($hDbPrp, "BEGIN;")	<> $SQLITE_OK Then MessageErreur("Erreur : BEGIN TRANSACTION Texte")
	_SQlite_Query($hDbPrp, "SELECT PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateModification, PrpDateUtilisation FROM TexteOld ORDER BY PrpOrdre ASC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		$sDateAvant = $sDateClassement
		If $sData[7] <> "" Then
			If $sData[7] > $sDateClassement Then $sDateClassement = $sData[7]
		Else
			If ($sData[6] <> "") And ($sData[6] > $sDateClassement) Then $sDateClassement = $sData[6]
		EndIf
		If $sDateAvant = $sDateClassement Then $sDateClassement = _AjouterDate($sDateClassement, 10)
		$iRefSynchro = Ceiling(Random($iRefSynchroMin, $iRefSynchroMax))
		If $sData[7] = "" Then ; Date Modification Nulle ?
			If _SQLite_Exec($hDbPrp, "INSERT INTO Texte (PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro) VALUES " & _
					"('" & _Quote($sData[0]) & "', '" & _Quote($sData[1]) & "', '" & $sData[2] & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _
					_Quote($sData[5]) & "', '" & $sData[6] & "', '" & $sData[8] & "', '" & $sDateClassement & "', '" & $iRefSynchro & "');") _
					<> $SQLITE_OK Then MessageErreur("Erreur : INSERT INTO Texte DateCreation=" & $sData[6])
		Else
			If _SQLite_Exec($hDbPrp, "INSERT INTO Texte (PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateModification, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro) VALUES " & _
					"('" & _Quote($sData[0]) & "', '" & _Quote($sData[1]) & "', '" & $sData[2] & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _Quote($sData[5]) & _
					"', '" & $sData[6] & "', '" & $sData[7] & "', '" & $sData[8] & "', '" & $sDateClassement & "', '" & $iRefSynchro & "');") _
					<> $SQLITE_OK Then MessageErreur("Erreur : INSERT INTO Texte DateModification=" & $sData[7])
		EndIf
		$iCompteur += 1
		GUICtrlSetData($Label2, "Table Texte, ligne " & $iCompteur)
		Sleep(1)
	WEnd
	_SQLite_QueryFinalize($hQuery)
	If _SQLite_Exec($hDbPrp, "COMMIT;")	<> $SQLITE_OK Then MessageErreur("Erreur : COMMIT TRANSACTION Texte")
	If _SQLite_Exec($hDbPrp, "DROP TABLE TexteOld;") <> $SQLITE_OK Then MessageErreur("Erreur : DROP TABLE TexteOld")
	;
	;---- Table Image : Changement de structure ---------------------------------------------------
	$sDateClassement = "2010-01-01 01:01:01"
	GUICtrlSetData($Label2, "Changement de structure de la Table Image")
	If _SQLite_Exec($hDbPrp, "ALTER TABLE Image RENAME TO ImageOld;") <> $SQLITE_OK Then MessageErreur("Erreur : ALTER TABLE Image RENAME TO ImageOld")
	If _SQLite_Exec($hDbPrp, "CREATE TABLE Image (ImgImage BLOB, ImgVignette BLOB, ImgTitre TEXT, ImgProvenance TEXT, ImgCommentaire TEXT, ImgDateCreation TIMESTAMP, ImgDateModification TIMESTAMP, ImgDateUtilisation TIMESTAMP, ImgDateClassement TIMESTAMP NOT NULL, ImgRefSynchro INTEGER NOT NULL, CONSTRAINT [] PRIMARY KEY (ImgDateClassement, ImgRefSynchro));") _
									<> $SQLITE_OK Then MessageErreur("Erreur : CREATE TABLE Image")
	If _SQLite_Exec($hDbPrp, "BEGIN;")	<> $SQLITE_OK Then MessageErreur("Erreur : BEGIN TRANSACTION Image")
	$iCompteur = 0
	_SQlite_Query($hDbPrp, "SELECT ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateModification, ImgDateUtilisation FROM ImageOld ORDER BY ImgOrdre ASC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		If $sData[6] <> "" Then
			If $sData[6] > $sDateClassement Then $sDateClassement = $sData[6]
		Else
			If ($sData[5] <> "") And ($sData[5] > $sDateClassement) Then $sDateClassement = $sData[5]
		EndIf
		If $sDateAvant = $sDateClassement Then $sDateClassement = _AjouterDate($sDateClassement, 10)
		$iRefSynchro = Ceiling(Random($iRefSynchroMin, $iRefSynchroMax))
		If $sData[6] = "" Then ; Date Modification Nulle ?
			If _SQLite_Exec($hDbPrp, "INSERT INTO Image (ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro) VALUES " & _
					"('" & $sData[0] & "', '" & $sData[1] & "', '" & _Quote($sData[2]) & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & $sData[5] &  "', '" & _
					$sData[7] & "', '" & $sDateClassement & "', '" & $iRefSynchro & "');")  <> $SQLITE_OK Then MessageErreur("Erreur : INSERT INTO Image DateCreation=" & $sData[5])
		Else
			If _SQLite_Exec($hDbPrp, "INSERT INTO Image (ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateModification, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro) VALUES " & _
					"('" & $sData[0] & "', '" & $sData[1] & "', '" & _Quote($sData[2]) & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & $sData[5] & "', '" & _
					$sData[6] &  "', '" & $sData[7] & "', '" & $sDateClassement & "', '" & $iRefSynchro & "');")  <> $SQLITE_OK Then MessageErreur("Erreur : INSERT INTO Image DateModification=" & $sData[6])
		EndIf
		$iCompteur += 1
		GUICtrlSetData($Label2, "Table Image, ligne " & $iCompteur)
		Sleep(1)
	WEnd
	_SQLite_QueryFinalize($hQuery)
	If _SQLite_Exec($hDbPrp, "COMMIT;")	<> $SQLITE_OK Then MessageErreur("Erreur : COMMIT TRANSACTION Image")
	If _SQLite_Exec($hDbPrp, "DROP TABLE ImageOld;") <> $SQLITE_OK Then MessageErreur("Erreur : DROP TABLE ImageOld")
	;
	;---- Table CodeEntete : Ajout de colonnes ------------------------------------------------------
	GUICtrlSetData($Label2, "Changement de structure de la Table CodeEntete")
	If _SQLite_Exec($hDbPrp, "ALTER TABLE CodeEntete ADD CEnDateCreation TIMESTAMP;") <> $SQLITE_OK Then MessageErreur("Erreur : ALTER TABLE CodeEntete ADD CEnDateCreation")
	If _SQLite_Exec($hDbPrp, "ALTER TABLE CodeEntete ADD CEnDateModification TIMESTAMP;") <> $SQLITE_OK Then MessageErreur("Erreur : ALTER TABLE CodeEntete ADD CEnDateModification")
	$iCompteur = 0
	_SQlite_Query($hDbPrp, "SELECT CEnRef FROM CodeEntete ORDER BY CEnType, CEnOrdre;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		If _SQLite_Exec($hDbPrp, "UPDATE CodeEntete SET CEnDateCreation='" & _DateHeureJour(3) & "' WHERE CEnRef=" & $sData[0] & ";") <> $SQLITE_OK Then _
			MessageErreur("Erreur : UPDATE CodeEntete")
		$iCompteur += 1
		GUICtrlSetData($Label2, "Table CodeEntete, ligne " & $iCompteur)
		Sleep(100)
	WEnd
	;
	;----- Cration table HistoSuppression --------------------------------------------------------
	GUICtrlSetData($Label2, "Cration de la table HistoSuppression")
	If _SQLite_Exec($hDbPrp, "CREATE TABLE HistoSuppression (HspDateSuppresssion TIMESTAMP, HspType Texte, HspRefSynchro INTEGER, HspDateCreation TIMESTAMP);") <> $SQLITE_OK Then _
		MessageErreur("Erreur : Cration impossible")
	;
	;----- Mise  jour de ParamN-PauseApresAppuiTouche --------------------------------------------
	GUICtrlSetData($Label2, "Mise  jour table Parametre")
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT PrmValNum FROM Parametre WHERE PrmCle='ParamN-PauseApresAppuiTouche';", $sData) = $SQLITE_OK Then
		If Number($sData[0]) = 50 Then ; Si la valeur initiale n'a pas t change alors on passe  200
			If _SQLite_Exec($hDbPrp, "UPDATE Parametre SET PrmValNum='200' WHERE PrmCle='ParamN-PauseApresAppuiTouche';") <> $SQLITE_OK Then _
										MessageErreur("Erreur : UPDATE Parametre PauseApresAppuiTouche")
		EndIf
	EndIf
	;
	; Fin - Mise  jour de la version
	Return MiseAJourChampVersion(1.1)
EndFunc


; ========== Fonctions secondaires ================================================================


Func MiseAJourChampVersion($dVerUpdate)
	If _SQLite_Exec($hDbPrp, "UPDATE Parametre SET PrmValNum='" & $dVerUpdate & "' WHERE PrmCle='Version';") = $SQLITE_OK Then
		Return True
	Else
		MessageErreur("Erreur : UPDATE PrmValNum=" & $dVerUpdate & " PrmCle=Version")
		Return False
	EndIf
EndFunc


Func MessageErreur($sMessErr, $bSortie = True)
	GUICtrlSetState($ButtonOK, $GUI_SHOW)
	GUICtrlSetData($LabelErreur, $sMessErr)
	While 1
		If GUIGetMsg() = $ButtonOK Then ExitLoop
		Sleep(10)
	WEnd
	If $bSortie Then
		_SQLite_Close($hDbPrp)
		_SQLite_Shutdown()
		Exit
	EndIf
EndFunc
