#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_Icon=ClipSpirit-Synchro.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Module de Synchronisation
#AutoIt3Wrapper_Res_Description=ClipSpirit - L'esprit de votre presse-papier
#AutoIt3Wrapper_Res_Fileversion=1.2.0.10
#AutoIt3Wrapper_Res_LegalCopyright=By Ahbadiane
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ---------------------------------------------------------------------------

	ClipSpirit-Synchro - Module de Synchronisation
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Janvier 2011 - Septembre 2011

	BUG & Evolutions : A placer dans ClipSpirit.au3

#ce ---------------------------------------------------------------------------

#include <Constants.au3>
#include <Crypt.au3>
#include <EditConstants.au3>
#include <FTPEx.au3>
#include <Misc.au3>
#include <StaticConstants.au3>
#include <String.au3>
#include <Timers.au3>
#include <WindowsConstants.au3>
#include "ClipSpiritLib.au3"
#include "ClipSpiritDB.au3"
#include "ClipSpirit-SynchroRes.au3"


AutoItSetOption("MustDeclareVars", 1)
Opt("WinTitleMatchMode", 3) ;1=start, 2=subStr, 3=exact, 4=advanced, -1 to -4=Nocase

;----- TimerIcones
Global $iIconesTimer = _Timer_Init()
Global $iIconesNum = 1

;----- Base de donnes --------------------------------------------------------
Global $dVersionDB = DbOuvrir($scProgSynchro)
If $dVersionDB = "" Then Exit

;----- Variables globales -----------------------------------------------------
Global Const $sSynchronisation = DbParamLireTexte("Synchronisation", "") ; "S"=Serveur, "L"=support Local
Global $sSynchroNomMachine = DbParamLireTexte("SynchroNomMachine", "")
If $sSynchroNomMachine = "" Then $sSynchroNomMachine = @ComputerName
$sSynchroNomMachine = StringLeft($sSynchroNomMachine, $iSynchroLongeurNomMachine)
Global Const $sSynchroCleCrypt = DbParamLireTexte("SynchroCleCrypt", "")
Global Const $bSynchroCleCrypt = ($sSynchroCleCrypt <> "")
Global $sSynchroRepertoireLocal = DbParamLireTexte("SynchroRepertoireLocal", $scAppliTitreGeneral & "-Synchro")
Global Const $sSynchroServeur = DbParamLireTexte("SynchroServeur", "")
Global Const $sSynchroUtilisateur = DbParamLireTexte("SynchroUtilisateur", "")
Global Const $sSynchroMotPasseCrypte = DbParamLireTexte("SynchroMotPasse", "")
Global $sSynchroDossierServeur = DbParamLireTexte("SynchroDossierServeur", "")
Global Const $bSynchronisationTexte = DbParamLireBoolean("SynchronisationTexte", False)
Global Const $bSynchronisationImage = DbParamLireBoolean("SynchronisationImage", False)
Global Const $bSynchronisationScript = DbParamLireBoolean("SynchronisationScript", False)
Global Const $sSynchroDateDernierSynchroEnvoyeTexte = DbParamLireTexte("SynchroDateDernierSynchroEnvoyeTexte", "") ; Format AAAA-MM-JJ HH:MM:SS.SSS
Global Const $sSynchroDateDernierSynchroEnvoyeImage = DbParamLireTexte("SynchroDateDernierSynchroEnvoyeImage", "") ; Format AAAA-MM-JJ HH:MM:SS.SSS
Global Const $sSynchroDateDernierSynchroEnvoyeScript = DbParamLireTexte("SynchroDateDernierSynchroEnvoyeScript", "") ; Format AAAA-MM-JJ HH:MM:SS.SSS
Global Const $sSynchroDateDernierSynchroRecu = DbParamLireTexte("SynchroDateDernierSynchroRecu", "") ; Format AAAAMMJJHHMMSS
Global Const $bSynchroAjoutNomMachineCommentaire = DbParamLireBoolean("SynchroAjoutNomMachineCommentaire", False)
Global Const $sSynchroSupportLocalListe = StringSplit(DbParamLireTexte("SynchroSupportLocal", ""), "|")
Global $iSynchroTempsIconeFin = DbParamLireNum("SynchroTempsIconeFin", 10) * 1000 ; en milisecondes
Global Const $iSynchroTempsMessageFin = DbParamLireNum("SynchroTempsMessageFin", 8) ; en secondes
Global $sSynchroSupportLocal
Global Const $scCorpsNomFicCree = "_" & $scAppliTitreGeneral & "_"
Global Const $sDateSynchroNomFic = _DateHeureJour(5)
Global Const $sDateSynchroData = _DateHeureJour(3)
Global $sSynchroRacineFicCree = $sDateSynchroNomFic & $scCorpsNomFicCree & $sSynchroNomMachine
Global $sSynchroNomFicCree = $sSynchroRacineFicCree & ".db"
If $bSynchroCleCrypt Then $sSynchroNomFicCree &= "c"
Global $hFTP, $IdFTP
Global $iNbInfoEnvoye, $iNbFichierRecu, $iNbLigneTexteRecu, $iNbLigneFavorisRecu, $iNbLigneImageRecu, $iNbLigneScriptRecu
Global $sTrayTipLong, $sTrayTipCourt
Global Const $scFicLog = @ScriptDir & "\" & $scAppliTitreGeneral & "-Synchro Trace.log"

;----- Une seule instance -----------------------------------------------------
If _Singleton($scProgSynchro,1) = 0 Then
	MsgBox(4144, $scMsgErreur, "L'application est dj lance." & @CRLF & "Rechercher l'icne en bas  droite de votre cran")
	Exit
EndIf

;----- TrayIcon (Minimum pour le mode non silencieux) -------------------------
Opt("TrayAutoPause", 0)
Opt("TrayMenuMode", 3)
TraySetToolTip("Synchronisation de " & $scAppliTitreGeneral & " " & $scAuteur & " v" & $scVersion)

;----- Synchronisation silencieuse ? ------------------------------------------
Global $bSilence = False
If $CmdLine[0] = 1 Then
	If $CmdLine[1] = "Silence" Then $bSilence = True
EndIf
If Not $bSilence Then
	If EcranModif(False) <> 1 Then Sortie()
EndIf

;----- TrayIcon (suite) -------------------------------------------------------
Global $hTrayModif = TrayCreateItem("Modifier l'excution de la prochaine synchronisation")
Global $hTrayFicLog = TrayCreateItem("Ouvrir le fichier de suivi")
TrayCreateItem("")
Global $hTrayQuitter = TrayCreateItem("Fermer la synchronisation ClipSpirit")

;----- Partie principale ------------------------------------------------------
If Not Initialisation() Then PrepaSortie(False)

;----- Prparation et envoi des donnes locales
$iNbInfoEnvoye = PreparationEtEnvoiDonneesLocales()

;----- Rception et traitement des donnes distantes
If $iNbInfoEnvoye >= 0 Then $iNbFichierRecu = ReceptionEtTraitementDonneesDistantes()

;----- Faire le mnage sur le serveur ou support local
NettoyerPartage()

;----- Fermeture de la connexion FTP ------------------------------------------
If $sSynchronisation = "S" Then FermerConnexionFTP()

;----- Ecriture fichier de log du synchro -------------------------------------
EcritureLog()

;----- Sortie de l'application ------------------------------------------------
PrepaSortie(($iNbInfoEnvoye >= 0 ))

Exit


; ========== Fonctions principales ===============================================================

Func Initialisation()
	Switch $sSynchronisation ; Type de synchronisation
		Case "S" ; Serveur ----------------------------------------------------
			;----- Dossier distant
			If StringRight($sSynchroDossierServeur, 2) <> "/" Then $sSynchroDossierServeur &= "/"
			;----- Si pas de connextion internet => on sort
			If Not ConnexionInternetOK() Then Return False
			;----- ConnexionFTP OK ?
			If Not OuvrirConnexionFTP() Then Return False
		Case "L" ; support local ----------------------------------------------
			;----- Support accessible et affectation de $sSynchroSupportLocal
			If Not SupportAccessible() Then Return False
		Case Else
			SynchroTrace("Synchronisation non paramtre", "", True, True)
			Return False
	EndSwitch
	;----- Rpertoire Local de Synchro
	If $sSynchroRepertoireLocal = "" Then $sSynchroRepertoireLocal = @ScriptDir
	If StringRight($sSynchroRepertoireLocal, 1) <> "\" Then $sSynchroRepertoireLocal &= "\"
	If (StringLeft($sSynchroRepertoireLocal, 1) <> "\") And (StringInStr($sSynchroRepertoireLocal, ":") = 0) Then $sSynchroRepertoireLocal = @ScriptDir & "\" & $sSynchroRepertoireLocal
	If Not _RepertoireExistant($sSynchroRepertoireLocal) Then
		If Not DirCreate($sSynchroRepertoireLocal) Then
			MsgBox(4112, $scMsgErreur, "Le dossier de synchronisation (" & $sSynchroRepertoireLocal & ") ne peut pas tre cr. Changez le dans vos prfrences")
			Return False
		EndIf
	EndIf
	;
	Return True
EndFunc


Func PreparationEtEnvoiDonneesLocales()
	Local $bOK, $iNbInfo = 0
	;----- Cration de la base et des tables
	Local $hDbSynchro = _SQLite_Open($sSynchroRepertoireLocal & $sSynchroRacineFicCree & ".db")
	DbCreerBase($hDbSynchro, "Synchro")
	;----- Begin Transaction
	_SQLite_Exec($hDbPrp, "BEGIN;")
	_SQLite_Exec($hDbSynchro, "BEGIN;")
	;----- Transfert de la table HistoSuppression
	$bOK = TransfertHistoSupp($iNbInfo, $hDbSynchro)
	;----- Transfert de la table Texte
	If $bOK And $bSynchronisationTexte Then $bOK = TransfertTexte($iNbInfo, $hDbSynchro)
	;----- Transfert de la table Image
	If $bOK And $bSynchronisationImage Then $bOK = TransfertImage($iNbInfo, $hDbSynchro)
	;----- Transfert de la table Script
	If $bOK And $bSynchronisationScript Then $bOK = TransfertScript($iNbInfo, $hDbSynchro)
	;----- Commit ou RollBack
	If $bOK Then
		_SQLite_Exec($hDbSynchro, "COMMIT;")
		_SQLite_Exec($hDbPrp, "COMMIT;")
	Else
		_SQLite_Exec($hDbSynchro, "ROLLBACK;")
		_SQLite_Exec($hDbPrp, "ROLLBACK;")
	EndIf
	;----- Fermeture de la base de transfert
	_SQLite_Close($hDbSynchro)
	;----- Crypter le fichier
	If $bOK And $bSynchroCleCrypt Then $bOK = CrypterFichier($sSynchroRepertoireLocal & $sSynchroRacineFicCree & ".db")
	;----- Envoi du fichier
	If $bOK And ($iNbInfo > 0) Then $bOK = EnvoyerDonnees($sSynchroRepertoireLocal & $sSynchroNomFicCree, $sSynchroDossierServeur & $sSynchroNomMachine & "/" & $sSynchroNomFicCree, $sSynchroSupportLocal & $sSynchroNomMachine & "\" & $sSynchroNomFicCree)
	;----- Mise  jour de la table HistoSuppression
	If $bOK And ($iNbInfo > 0) Then $bOK = MAJHistoSupp()
	;----- Nouvelle Heure de rfrence de Synchro des lments envoys
	If $bOK Then
		If $bSynchronisationTexte Then DbParamMAJTexte("SynchroDateDernierSynchroEnvoyeTexte", $sDateSynchroData)
		If $bSynchronisationImage Then DbParamMAJTexte("SynchroDateDernierSynchroEnvoyeImage", $sDateSynchroData)
		If $bSynchronisationScript Then DbParamMAJTexte("SynchroDateDernierSynchroEnvoyeScript", $sDateSynchroData)
	EndIf
	;----- Suppression du fichier
	FileDelete($sSynchroRepertoireLocal & $sSynchroRacineFicCree & ".*") ; "*" Pour supprimer l'ventuel journal Sqlite
	;----- Fin
	If $bOK Then
		Return $iNbInfo
	Else
		Return -1
	EndIf
EndFunc


Func ReceptionEtTraitementDonneesDistantes()
	Local $iNbFicOK = 0, $iNbEnTrop, $iNbMax
	Local $hQuery, $sData
	Local $iDossier, $sDossier, $iFichier, $sListeFichier, $sFichier, $sListeAutresMachines
	; Liste des dossiers
	$sListeAutresMachines = ListeAutresMachines()
	For $iDossier = 1 To $sListeAutresMachines[0]
		$sDossier = $sListeAutresMachines[$iDossier]
		; Liste des fichiers
		If $sSynchronisation = "S" Then ; Serveur
			$sListeFichier = ListeFichiersDossierDistant($IdFTP, $sSynchroDossierServeur & $sDossier, "F")
		Else ; support local
			$sListeFichier = _FileListToArray($sSynchroSupportLocal & $sDossier, "*.db*", 1)
			If $sListeFichier = 0 Then
				Dim $sListeFichier[1]
				$sListeFichier[0] = 0
			EndIf
		EndIf
		If $sListeFichier[0] = 0 Then ContinueLoop
		_ArraySort($sListeFichier, 0, 1, 0, 0) ; Tri de la liste
		For $iFichier = 1 To $sListeFichier[0]
			ChangeIcone()
			$sFichier = $sListeFichier[$iFichier]
			If Not FichierDistantAPrendre($sFichier, $sDossier) Then ContinueLoop
			If $sSynchronisation = "S" Then ; Serveur
				If Not TelechargerFichier($sFichier, $sSynchroDossierServeur & $sDossier & "/") Then ContinueLoop
			Else ; support local
				If Not CopierFichierDepuisSupportLocal($sSynchroSupportLocal & $sDossier & "\" & $sFichier, $sSynchroRepertoireLocal & $sFichier) Then ContinueLoop
			EndIf
			If TraitementFichierRapatrie($sFichier, $sDossier) Then
				$iNbFicOK += 1
				; Crer le fichier de Validation pour ce fichier rapatri
				CreerFichierOKRapatrie(StringLeft($sFichier, 14) & $scCorpsNomFicCree & $sSynchroNomMachine & ".log", $sDossier)
			EndIf
		Next
	Next
	;----- Suppression des lignes en trop // max des textes et images
	$iNbMax = DbParamLireNum("NbMaxItemTexte", 200)
	If $iNbMax > 0 Then
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT COUNT(ROWID) FROM Texte WHERE PrpEstFavoris='0';", $sData) = $SQLITE_OK Then
			$iNbEnTrop = $sData[0] - $iNbMax
			If $iNbEnTrop > 0 Then
				_SQlite_Query($hDbPrp, "SELECT ROWID, PrpDateCreation, PrpRefSynchro, PrpPlus FROM Texte WHERE PrpEstFavoris='0' ORDER BY PrpDateClassement ASC, PrpRefSynchro ASC;", $hQuery)
				While (_SQLite_FetchData($hQuery, $sData) = $SQLITE_OK) And ($iNbEnTrop > 0)
					If _SQLite_Exec($hDbPrp, "DELETE FROM Texte WHERE ROWID='" & $sData[0] & "';") = $SQLITE_OK Then
						; raccourci  supprimer ?
						If StringInStr($sData[2], "|HKy=") > 0 Then FlagHotKey()
						DbAjoutHistoSuppr("T", $sData[1], $sData[2])
					EndIf
					$iNbEnTrop -= 1
				WEnd
				_SQLite_QueryFinalize($hQuery)
			EndIf
		EndIf
	EndIf
	ChangeIcone()
	$iNbMax = DbParamLireNum("NbMaxItemImage", 20)
	If $iNbMax > 0 Then
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT COUNT(ROWID) FROM Image;", $sData) = $SQLITE_OK Then
			$iNbEnTrop = $sData[0] - $iNbMax
			If $iNbEnTrop > 0 Then
				_SQlite_Query($hDbPrp, "SELECT ROWID, ImgDateCreation, ImgRefSynchro FROM Image ORDER BY ImgDateClassement ASC, ImgRefSynchro ASC;", $hQuery)
				While (_SQLite_FetchData($hQuery, $sData) = $SQLITE_OK) And ($iNbEnTrop > 0)
					If _SQLite_Exec($hDbPrp, "DELETE FROM Image WHERE ROWID='" & $sData[0] & "';") = $SQLITE_OK Then DbAjoutHistoSuppr("I", $sData[1], $sData[2])
					$iNbEnTrop -= 1
				WEnd
				_SQLite_QueryFinalize($hQuery)
			EndIf
		EndIf
	EndIf
	ChangeIcone()
	;
	Return $iNbFicOK
EndFunc


Func TraitementFichierRapatrie($sFichier, $sDossier)
	Local $bOK = True
	;----- Decrypter le fichier
	If $bSynchroCleCrypt And (StringRight($sFichier, 1) = "c") Then
		$sFichier = StringLeft($sFichier, StringLen($sFichier) -1)
		$bOK = DecrypterFichier($sSynchroRepertoireLocal & $sFichier)
	EndIf
	If $bOK Then
		;----- Cration de la base et des tables
		Local $hDbSynchro = _SQLite_Open($sSynchroRepertoireLocal & $sFichier)
		;----- Begin Transaction
		_SQLite_Exec($hDbPrp, "BEGIN;")
		;----- Prise en compte de la table HistoSuppression
		$bOK = PriseEnCompteHistoSupp($hDbSynchro)
		;----- Prise en compte de la table Texte
		If $bOK And $bSynchronisationTexte Then $bOK = PriseEnCompteTexte($hDbSynchro, $sDossier)
		;----- Prise en compte de la table Image
		If $bOK And $bSynchronisationImage Then $bOK = PriseEnCompteImage($hDbSynchro, $sDossier)
		;----- Prise en compte des Scriptings
		If $bOK And $bSynchronisationScript Then $bOK = PriseEnCompteScript($hDbSynchro)
		;----- Commit ou RollBack
		If $bOK Then
			_SQLite_Exec($hDbPrp, "COMMIT;")
		Else
			_SQLite_Exec($hDbPrp, "ROLLBACK;")
		EndIf
		;----- Nouvelle Heure de rfrence de Synchro des lments Reus
		If $bOK Then DbParamMAJTexte("SynchroDateDernierSynchroRecu", $sDateSynchroNomFic)
		;----- Fermeture de la base de transfert
		_SQLite_Close($hDbSynchro)
	EndIf
	;----- Suppression des fichiers
	FileDelete($sSynchroRepertoireLocal & $sFichier & "*") ; "*" Pour supprimer l'ventuel journal Sqlite & dbc
	; Fin
	Return $bOK
EndFunc


Func CreerFichierOKRapatrie($sFichier, $sDossier)
	Local $b, $hFic = FileOpen($sSynchroRepertoireLocal & $sFichier, 2)
	If $hFic = -1 Then Return False
	If FileWriteLine($hFic, "Ne pas supprimer ce fichier sinon le fichier .db ou .dbc du mme nom ne sera jamais supprim") = 0 Then Return False
	If FileWriteLine($hFic, $sDateSynchroData) = 0 Then Return False
	If FileClose($hFic) = 0 Then Return False
	$b = EnvoyerDonnees($sSynchroRepertoireLocal & $sFichier, $sSynchroDossierServeur & $sDossier & "/" & $sFichier, $sSynchroSupportLocal & $sDossier & "\" & $sFichier)
	FileDelete($sSynchroRepertoireLocal & $sFichier) ; dans tous les cas supprimer le fichier dit temporaire
EndFunc


Func PriseEnCompteTexte($hDbSynchro, $sDossier)
	Local $hQuery, $s, $i, $sData1, $sData2
	_SQlite_Query($hDbSynchro, "SELECT PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro, PrpDateModification FROM Texte ORDER BY PrpDateClassement ASC, PrpRefSynchro ASC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData1) = $SQLITE_OK
		ChangeIcone()
		;----- La ligne existe dj? Si Oui alors on la supprime (pour la rcrer ensuite - c'est plus simple)
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID, PrpDateModification, PrpPlus FROM Texte WHERE PrpDateCreation='" & $sData1[6] & "' AND PrpRefSynchro='" & $sData1[9] & "';", $sData2) = $SQLITE_OK Then
			;----- La ligne dans la base en cours est-elle plus rcente ?
			If $sData2[1] > $sData1[10] Then ContinueLoop
			If _SQLite_Exec($hDbPrp, "DELETE FROM Texte WHERE ROWID='" & $sData2[0] & "';") = $SQLITE_OK Then
				; raccourci  supprimer ?
				If StringInStr($sData2[2], "|HKy=") > 0 Then FlagHotKey()
			EndIf
		EndIf
		;----- Ajouter au Commentaire le nom de la machine
		If $bSynchroAjoutNomMachineCommentaire Then
			If $sData1[4] <> "" Then
				$s = $sData1[4]
				$i = StringInStr($s, "<")
				If (StringLeft($s, 1) = ">") And ($i <= ($iSynchroLongeurNomMachine + 2)) Then $s = StringMid($s, ($i + 1))
				$sData1[4] = StringLeft(">" & $sDossier & "<" & $s, $icLongMaxCommentaire)
			Else
				$sData1[4] = ">" & $sDossier & "<"
			EndIf
		EndIf
		;----- Cration de la ligne
		If $sData1[10] = "" Then ; Date de modification est-elle nulle
			If _SQLite_Exec($hDbPrp, "INSERT INTO Texte (PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro) VALUES " & _
							"('" & _Quote($sData1[0]) & "', '" & _Quote($sData1[1]) & "', '" & $sData1[2] & "', '" & _Quote($sData1[3]) & "', '" & _Quote($sData1[4]) _
							& "', '" & _Quote($sData1[5]) & "', '" & $sData1[6] & "', '" & $sData1[7] & "', '" & $sData1[8] & "', '" & $sData1[9] & "');") = $SQLITE_OK Then
				If $sData1[2] = '1' Then
					$iNbLigneFavorisRecu += 1
				Else
					$iNbLigneTexteRecu += 1
				EndIf
			EndIf
		Else
			If _SQLite_Exec($hDbPrp, "INSERT INTO Texte (PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro, PrpDateModification) VALUES " & _
							"('" & _Quote($sData1[0]) & "', '" & _Quote($sData1[1]) & "', '" & $sData1[2] & "', '" & _Quote($sData1[3]) & "', '" & _Quote($sData1[4]) _
							& "', '" & _Quote($sData1[5]) & "', '" & $sData1[6] & "', '" & $sData1[7] & "', '" & $sData1[8] & "', '" & $sData1[9] & "', '" & $sData1[10] & "');") = $SQLITE_OK Then
				If $sData1[2] = '1' Then
					$iNbLigneFavorisRecu += 1
				Else
					$iNbLigneTexteRecu += 1
				EndIf
			EndIf
		EndIf
		; raccourci  crer ?
		If StringInStr($sData1[5], "|HKy=") > 0 Then FlagHotKey()
	WEnd
	Return True
EndFunc


Func PriseEnCompteImage($hDbSynchro, $sDossier)
	Local $hQuery, $s, $i, $sData1, $sData2
	_SQlite_Query($hDbSynchro, "SELECT ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro, ImgDateModification FROM Image ORDER BY ImgDateClassement ASC, ImgRefSynchro ASC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData1) = $SQLITE_OK
		ChangeIcone()
		;----- La ligne existe dj? Si Oui alors on la supprime (pour la rcrer ensuite - c'est plus simple)
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID, ImgDateModification FROM Image WHERE ImgDateCreation='" & $sData1[5] & "' AND ImgRefSynchro='" & $sData1[8] & "';", $sData2) = $SQLITE_OK Then _
			;----- La ligne dans la base en cours est-elle plus rcente ?
			If $sData2[1] > $sData1[9]  Then ContinueLoop
			_SQLite_Exec($hDbPrp, "DELETE FROM Image WHERE ROWID='" & $sData2[0] & "';")
		EndIf
		;----- Ajouter au Commentaire le nom de la machine
		If $bSynchroAjoutNomMachineCommentaire Then
			If $sData1[4] <> "" Then
				$s = $sData1[4]
				$i = StringInStr($s, "<")
				If (StringLeft($s, 1) = ">") And ($i <= ($iSynchroLongeurNomMachine + 2)) Then $s = StringMid($s, ($i + 1))
				$sData1[4] = StringLeft(">" & $sDossier & "<" & $s, $icLongMaxCommentaire)
			Else
				$sData1[4] = ">" & $sDossier & "<"
			EndIf
		EndIf
		;----- Cration de la ligne
		If $sData1[9] = "" Then ; Date de modification est-elle nulle
			If _SQLite_Exec($hDbPrp, "INSERT INTO Image (ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro) VALUES " & _
							"('" & $sData1[0] & "', '" & $sData1[1] & "', '" & $sData1[2] & "', '" & _Quote($sData1[3]) & "', '" & _Quote($sData1[4]) _
							& "', '" & $sData1[5] & "', '" & $sData1[6] & "', '" & $sData1[7] & "', '" & $sData1[8] & "');") = $SQLITE_OK Then _
				$iNbLigneImageRecu += 1
		Else
			If _SQLite_Exec($hDbPrp, "INSERT INTO Image (ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro, ImgDateModification) VALUES " & _
							"('" & $sData1[0] & "', '" & $sData1[1] & "', '" & $sData1[2] & "', '" & _Quote($sData1[3]) & "', '" & _Quote($sData1[4]) _
							& "', '" & $sData1[5] & "', '" & $sData1[6] & "', '" & $sData1[7] & "', '" & $sData1[8] & "', '" & $sData1[9] & "');") = $SQLITE_OK Then _
				$iNbLigneImageRecu += 1
		EndIf
	WEnd
	Return True
EndFunc


Func PriseEnCompteScript($hDbSynchro)
	Local $hQuery, $hQuery2, $sData1, $sData2, $sType, $dOrdre, $dMaxOrdre, $iRefOld, $iRefNew, $iRefSynchro, $bIdem
	_SQlite_Query($hDbSynchro, "SELECT CEnRef, CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnCode, CEnTpsMaxExe, CEnToucheActivation, CEnActif, CEnDateCreation, CEnDateModification FROM CodeEntete ORDER BY CEnType, CEnOrdre;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData1) = $SQLITE_OK
		ChangeIcone()
		$iRefSynchro = $sData1[0]
		; Changement de Type ? alors calcul de $dMaxOrdre
		If $sData1[1] <> $sType Then
			$sType = $sData1[1]
			If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnRef, CEnOrdre FROM CodeEntete WHERE CEnType = '" & $sData1[1] & "' ORDER BY CEnOrdre DESC;", $sData2) = $SQLITE_OK Then
				$iRefOld = $sData2[0]
				$dMaxOrdre = $sData2[1]
			Else
				$iRefOld = -1
				$dMaxOrdre = 0
			EndIf
		EndIf
		;----- La ligne existe dj? Si Oui alors on la supprime (pour la rcrer ensuite - c'est plus simple), on garde le N d'ordre
		$bIdem = False
		; Si Type A (Automatique) il ne peut y avoir qu'une ligne, on garde ma plus rcente
		If $sType = "A" Then
			If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnRef, CEnDateModification, CEnOrdre, CEnDateCreation FROM CodeEntete WHERE CEnType = '" & $sType & "';", $sData2) = $SQLITE_OK Then
				If ($sData2[1] = "") And ($sData1[10] = "") Then ; Les Date Modif Actuelle et Date Modif Synchro sont vides
					If $sData2[3] > $sData1[9] Then ContinueLoop ; Si Date Crat Actuelle > Date Crat Synchro alors on passe
				ElseIf ($sData2[1] <> "") And ($sData1[10] <> "") Then ; Les Date Modif Actuelle et Date Modif Synchro existent
					If $sData2[1] > $sData1[10] Then ContinueLoop ; Si Date de modif Actuelle > Date Modif Synchro alors on passe
				ElseIf $sData1[10] = "" Then ; Date Modif Synchro vide (date modif Actuelle n'est pas vide)
					If $sData2[1] > $sData1[9] Then ContinueLoop ; Si Date Modif Actuelle > Date Crat Synchro alors on passe
				Else ; Date Modif Actuelle vide (date modif synchro n'est pas vide)
					If $sData2[3] > $sData1[10] Then ContinueLoop ; Si Date Crat Actuelle > Date Modif Synchro alors on passe
				EndIf
				$bIdem = True
			EndIf
		Else
			;----- La ligne dans la base en cours est-elle plus rcente ?
			If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnRef, CEnDateModification, CEnOrdre FROM CodeEntete WHERE CEnType = '" & $sType & "' AND CEnDateCreation='" & $sData1[9] & "';", $sData2) = $SQLITE_OK Then
				If $sData2[1] > $sData1[10] Then ContinueLoop
				$bIdem = True
			EndIf
		EndIf
		If $bIdem Then
			_SQLite_Exec($hDbPrp, "DELETE FROM CodeEntete WHERE CEnRef='" & $sData2[0] & "';")
			$dOrdre = $sData2[2]
		Else
			$dMaxOrdre += 1
			$dOrdre = $dMaxOrdre
		EndIf
		;----- Cration de la ligne d'entte
		If $sData1[10] = "" Then
			If _SQLite_Exec($hDbPrp, "INSERT INTO CodeEntete (CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnCode, CEnTpsMaxExe, CEnToucheActivation, CEnActif, CEnDateCreation) VALUES " & _
							"('"& $sType & "', '" & $dOrdre & "', '" & _Quote($sData1[3]) & "', '" & _Quote($sData1[4]) & "', '" & _Quote($sData1[5]) & _
							"', '" & $sData1[6] & "', '" & $sData1[7] & "', '" & $sData1[8] & "', '" & $sData1[9] & "');") = $SQLITE_OK Then _
				$iNbLigneScriptRecu += 1
		Else
			If _SQLite_Exec($hDbPrp, "INSERT INTO CodeEntete (CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnCode, CEnTpsMaxExe, CEnToucheActivation, CEnActif, CEnDateCreation, CEnDateModification) VALUES " & _
							"('" & $sType & "', '" & $dOrdre & "', '" & _Quote($sData1[3]) & "', '" & _Quote($sData1[4]) & "', '" & _Quote($sData1[5]) & _
							"', '" & $sData1[6] & "', '" & $sData1[7] & "', '" & $sData1[8] & "', '" & $sData1[9] & "', '" & $sData1[10] & "');") = $SQLITE_OK Then _
				$iNbLigneScriptRecu += 1
		EndIf
		; Retrouver le n CDeRefEntete
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnRef FROM CodeEntete WHERE CEnDateCreation='" & $sData1[9] & "' AND CEnType='" & $sType & "' AND CEnOrdre='" & $dOrdre & "';", $sData2) = $SQLITE_OK Then
			$iRefNew = $sData2[0]
		Else
			ContinueLoop
		EndIf
		;----- Suppression des anciennes lignes de corps
		If $iRefOld <> -1 Then _SQLite_Exec($hDbPrp, "DELETE FROM CodeDetail WHERE CDeRefEntete='" & $iRefOld & "';")
		;----- Cration des lignes de corps
		_SQlite_Query($hDbSynchro, "SELECT CDeOrdre, CDeParam1, CDeParam2, CDeParam3, CDeParam4, CDeParam5, CDeType FROM CodeDetail WHERE CDeRefEntete='" & $iRefSynchro & "' ORDER BY CDeOrdre;", $hQuery2)
		While _SQLite_FetchData($hQuery2, $sData2) = $SQLITE_OK
			_SQLite_Exec($hDbPrp, "INSERT INTO CodeDetail (CDeRefEntete, CDeOrdre, CDeParam1, CDeParam2, CDeParam3, CDeParam4, CDeParam5, CDeType) VALUES " & _
							"('" & $iRefNew & "', '"  & $sData2[0] & "', '" & _Quote($sData2[1]) & "', '" & _Quote($sData2[2]) & "', '" & _
							_Quote($sData2[3]) & "', '" & _Quote($sData2[4]) & "', '" & _Quote($sData2[5]) & "', '" & $sData2[6] & "');")
		WEnd
	WEnd
	Return True
EndFunc


Func PriseEnCompteHistoSupp($hDbSynchro)
	Local $hQuery, $sData1, $sData2
	_SQlite_Query($hDbSynchro, "SELECT HspDateSuppresssion, HspType, HspRefSynchro, HspDateCreation FROM HistoSuppression;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData1) = $SQLITE_OK
		ChangeIcone()
		If $sData1[1] = "T" Then ; Texte
			If Not $bSynchronisationTexte Then ContinueLoop
			If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID, PrpPlus FROM Texte WHERE PrpDateCreation='" & $sData1[3] & "' AND PrpRefSynchro='" & $sData1[2] & "';", $sData2) = $SQLITE_OK Then
				 ; DELETE sans remettre dans la table de HistoSuppression
				If _SQLite_Exec($hDbPrp, "DELETE FROM Texte WHERE ROWID='" & $sData2[0] & "';") = $SQLITE_OK Then
					; raccourci  supprimer ?
					If StringInStr($sData2[1], "|HKy=") > 0 Then FlagHotKey()
				EndIf
			EndIf
		ElseIf $sData1[1] = "I" Then ; Image
			If Not $bSynchronisationImage Then ContinueLoop
			If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID FROM Image WHERE ImgDateCreation='" & $sData1[3] & "' AND ImgRefSynchro='" & $sData1[2] & "';", $sData2) = $SQLITE_OK Then _
				_SQLite_Exec($hDbPrp, "DELETE FROM Image WHERE ROWID='" & $sData2[0] & "';") ; DELETE sans remettre dans la table de HistoSuppression
		ElseIf StringLeft($sData1[1], 1) = "S" Then ; Scripting
			If Not $bSynchronisationScript Then ContinueLoop
			If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnRef FROM CodeEntete WHERE CEnDateCreation='" & $sData1[3] & "' AND CEnType='" & StringRight($sData1[1], 1) & "';", $sData2) = $SQLITE_OK Then
				_SQLite_Exec($hDbPrp, "DELETE FROM CodeEntete WHERE CEnRef='" & $sData2[0] & "';") ; DELETE Entete sans remettre dans la table de HistoSuppression
				_SQLite_Exec($hDbPrp, "DELETE FROM CodeDetail WHERE CDeRefEntete='" & $sData2[0] & "';") ; DELETE Detail sans remettre dans la table de HistoSuppression
			EndIf
		EndIf
	WEnd
	Return True
EndFunc


Func FichierDistantAPrendre($sFichier, $sDossier)
	If $sFichier < $sSynchroDateDernierSynchroRecu Then Return False ; Fichier dj trait (date < dernire synchro)
	If Not StringIsDigit(StringLeft($sFichier, 14)) Then Return False ; Les 14 permiers caractress doivent tre numriques
	If StringMid($sFichier, 15, StringLen($scCorpsNomFicCree)) <> $scCorpsNomFicCree Then Return False ; du 15 au .. caractres doit tre gal  $scCorpsNomFicCree
	If StringMid($sFichier, (15 + StringLen($scCorpsNomFicCree)), StringLen($sDossier) + 1) <> ($sDossier & ".") Then Return False ; Les derniers caractres ne doivent tre gal au dossier actuel
	If (StringRight($sFichier, 3) <> ".db") And (StringRight($sFichier, 4) <> ".dbc") Then Return False ; uniquement les extensions .db & .dbc
	Return True
EndFunc


Func TelechargerFichier($sFichier, $sRepDistant)
	FileDelete($sSynchroRepertoireLocal & $sFichier)
	_FTP_ProgressDownload($IdFTP, $sSynchroRepertoireLocal & $sFichier, $sRepDistant & $sFichier, "CallBackUpDownload")
	Switch @error
		Case 0  ; OK
			Return True
		Case -6 ; Arrt utilisatuer
			FileDelete($sSynchroRepertoireLocal & $sFichier)
			Return False
		Case Else ; Erreur
			FileDelete($sSynchroRepertoireLocal & $sFichier)
			Return False
	EndSwitch
EndFunc


Func CopierFichierDepuisSupportLocal($sSource, $sDestination)
	If FileCopy($sSource, $sDestination, 1) = 1 Then
		Return True
	Else
		SynchroTrace("Copie du fichier '" & $sSource & "' vers '" & $sDestination & "' impossible", "Copie fichier impossible", True, True)
		Return False
	EndIf
EndFunc


Func CrypterFichier($sFic)
	Local $s
	ChangeIcone()
	_Crypt_EncryptFile($sFic, $sFic & "c", $sSynchroCleCrypt, $CALG_AES_128)
	If @error <> 0 Then
		Switch @error
			Case 1
				$s = "de cration de cl de cryptage"
			Case 2
				$s = "d'ouverture du fichier crypt"
			Case 3
				$s = "de cration du fichier final"
			Case 4, 5
				$s = "de cl de cryptage"
			Case Else
				$s = "inconue"
		EndSwitch
		SynchroTrace("Erreur " & $s & " en cryptant le fichier " & $sFic & "c", "Erreur de cryptage", True, True)
		Return False
	Else
		ChangeIcone()
		Return True
	EndIf
EndFunc


Func DecrypterFichier($sFic)
	Local $s
	ChangeIcone()
	_Crypt_DecryptFile($sFic & "c", $sFic, $sSynchroCleCrypt, $CALG_AES_128)
	If @error <> 0 Then
		Switch @error
			Case 1
				$s = "de cration de cl de cryptage"
			Case 2
				$s = "d'ouverture du fichier crypt"
			Case 3
				$s = "de cration du fichier final"
			Case 4, 5
				$s = "de cl de cryptage"
			Case Else
				$s = "inconue"
		EndSwitch
		SynchroTrace("Erreur " & $s & " en dcryptant le fichier " & $sFic & "c", "Erreur de dcryptage", True, True)
		Return False
	Else
		ChangeIcone()
		Return True
	EndIf
EndFunc


Func EnvoyerDonnees($sFicEnvoye, $sFicFTP, $sFicSupportLocal)
	Switch $sSynchronisation ; Type de synchronisation
		Case "S" ; Serveur ----------------------------------------------------
			_FTP_ProgressUpload($IdFTP, $sFicEnvoye, $sFicFTP, "CallBackUpDownload")
			Switch @error
			Case 0  ; OK
					Return True
				Case -6 ; Arrt utilisatuer
					Return False
				Case Else ; Erreur
					Sleep(1000)
					_FTP_FileDelete($IdFTP, $sFicFTP)
					SynchroTrace("Erreur d'envoi FTP du fichier '" & $sFicEnvoye & "' vers '" &  $sFicFTP & "'.", "Erreur d'envoi FTP de fichier", True, False)
					Return False
			EndSwitch
		Case "L" ; support local ----------------------------------------------
			If FileCopy($sFicEnvoye, $sFicSupportLocal, 1) = 1 Then
				Return True
			Else
				SynchroTrace("Copie du fichier '" & $sFicEnvoye & "' vers '" & $sFicSupportLocal & "' impossible.", "Copie fichier impossible", True, True)
				Return False
			EndIf
		Case Else
	EndSwitch
EndFunc


Func CallBackUpDownload($iPourcent)
	ChangeIcone()
	Return 1
EndFunc


Func TransfertTexte(ByRef $iNbInfo, $hDbSynchro)
	Local $hQuery, $sData
	; Toutes les lignes Cres (aprs le SynchroDateDernierSynchroEnvoye ET avant le DateSynchroData) ou Mises  jour (aprs le SynchroDateDernierSynchroEnvoye ET avant le DateSynchroData)
	_SQlite_Query($hDbPrp, "SELECT PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro, PrpDateModification FROM Texte WHERE ((PrpDateCreation>'" & _
							$sSynchroDateDernierSynchroEnvoyeTexte & "') AND (PrpDateCreation<='" & $sDateSynchroData & "')) OR ((PrpDateModification>'" & $sSynchroDateDernierSynchroEnvoyeTexte & "') AND (PrpDateModification<='" & $sDateSynchroData & "'));", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		ChangeIcone()
		If $sData[10] = "" Then ; Si PrpDateModification est vide alors on ne la prend pas en compte
			_SQLite_Exec($hDbSynchro, "INSERT INTO Texte (PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro) VALUES ('" & _
									_Quote($sData[0]) & "', '" & _Quote($sData[1]) & "', '" & $sData[2] & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _
									_Quote($sData[5]) & "', '" & $sData[6] & "', '" & $sData[7] & "', '" & $sData[8] & "', '" & $sData[9] & "');")
		Else
			_SQLite_Exec($hDbSynchro, "INSERT INTO Texte (PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpCommentaire, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpDateClassement, PrpRefSynchro, PrpDateModification) VALUES ('" & _
									_Quote($sData[0]) & "', '" & _Quote($sData[1]) & "', '" & $sData[2] & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _
									_Quote($sData[5]) & "', '" & $sData[6] & "', '" & $sData[7] & "', '" & $sData[8] & "', '" & $sData[9] & "', '" & $sData[10] & "');")
		EndIf
		$iNbInfo += 1
	WEnd
	Return True
EndFunc


Func TransfertImage(ByRef $iNbInfo, $hDbSynchro)
	Local $hQuery, $sData
	; Toutes les images cres (aprs le SynchroDateDernierSynchroEnvoye ET avant le DateSynchroData) ou Mises  jour (aprs le SynchroDateDernierSynchroEnvoye ET avant le DateSynchroData)
	_SQlite_Query($hDbPrp, "SELECT ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro, ImgDateModification FROM Image WHERE ((ImgDateCreation>'" & _
							$sSynchroDateDernierSynchroEnvoyeImage & "') AND (ImgDateCreation<='" & $sDateSynchroData & "')) OR ((ImgDateModification>'" & $sSynchroDateDernierSynchroEnvoyeImage & "') AND (ImgDateModification<='" & $sDateSynchroData & "'));", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		ChangeIcone()
		If $sData[9] = "" Then ; Si ImgDateModification est vide alors on ne la prend pas en compte
			_SQLite_Exec($hDbSynchro, "INSERT INTO Image (ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro) VALUES ('" & _
									$sData[0] & "', '" & $sData[1] & "', '" & _Quote($sData[2]) & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _
									$sData[5] & "', '" & $sData[6] & "', '" & $sData[7] & "', '" & $sData[8] & "');")
		Else
			_SQLite_Exec($hDbSynchro, "INSERT INTO Image (ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgCommentaire, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro, ImgDateModification) VALUES ('" & _
									$sData[0] & "', '" & $sData[1] & "', '" & _Quote($sData[2]) & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _
									$sData[5] & "', '" & $sData[6] & "', '" & $sData[7] & "', '" & $sData[8] & "', '" & $sData[9] & "');")
		EndIf
		$iNbInfo += 1
	WEnd
	Return True
EndFunc


Func TransfertScript(ByRef $iNbInfo, $hDbSynchro)
	Local $hQuery, $hQuery2, $sData, $iRef
	; Tous les scripts crs (aprs le SynchroDateDernierSynchroEnvoye ET avant le DateSynchroData) ou Mis  jour (aprs le SynchroDateDernierSynchroEnvoye ET avant le DateSynchroData)
	_SQlite_Query($hDbPrp, "SELECT CEnRef, CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnCode, CEnTpsMaxExe, CEnToucheActivation, CEnActif, CEnDateCreation, CEnDateModification FROM CodeEntete WHERE ((CEnDateCreation>'" & _
							$sSynchroDateDernierSynchroEnvoyeScript & "') AND (CEnDateCreation<='" & $sDateSynchroData & "')) OR ((CEnDateModification>'" & $sSynchroDateDernierSynchroEnvoyeScript & "') AND (CEnDateModification<='" & $sDateSynchroData & "'));", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		ChangeIcone()
		If $sData[10] = "" Then ; Si CEnDateModification est vide alors on ne la prend pas en compte
			_SQLite_Exec($hDbSynchro, "INSERT INTO CodeEntete (CEnRef, CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnCode, CEnTpsMaxExe, CEnToucheActivation, CEnActif, CEnDateCreation) VALUES ('" & _
									$sData[0] & "', '" & $sData[1] & "', '" & $sData[2] & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _
									_Quote($sData[5]) & "', '" & $sData[6] & "', '" & $sData[7] & "', '" & $sData[8] & "', '" & $sData[9] & "');")
		Else
			_SQLite_Exec($hDbSynchro, "INSERT INTO CodeEntete (CEnRef, CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnCode, CEnTpsMaxExe, CEnToucheActivation, CEnActif, CEnDateCreation, CEnDateModification) VALUES ('" & _
									$sData[0] & "', '" & $sData[1] & "', '" & $sData[2] & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _
									_Quote($sData[5]) & "', '" & $sData[6] & "', '" & $sData[7] & "', '" & $sData[8] & "', '" & $sData[9] & "', '" & $sData[10] & "');")
		EndIf
		;- Exporter le dtail
		$iRef = $sData[0]
		_SQlite_Query($hDbPrp, "SELECT CDeRefEntete, CDeOrdre, CDeType, CDeParam1, CDeParam2, CDeParam3, CDeParam4, CDeParam5 FROM CodeDetail WHERE CDeRefEntete='" & $iRef & "';", $hQuery2)
		While _SQLite_FetchData($hQuery2, $sData) = $SQLITE_OK
			_SQLite_Exec($hDbSynchro, "INSERT INTO CodeDetail (CDeRefEntete, CDeOrdre, CDeType, CDeParam1, CDeParam2, CDeParam3, CDeParam4, CDeParam5) VALUES ('" & _
								$sData[0] & "', '" & $sData[1] & "', '" & $sData[2] & "', '" & _Quote($sData[3]) & "', '" & _Quote($sData[4]) & "', '" & _Quote($sData[5]) & _
								"', '" & _Quote($sData[6]) & "', '" & _Quote($sData[7]) & "');")
		WEnd
		$iNbInfo += 1
	WEnd
	Return True
EndFunc


Func TransfertHistoSupp(ByRef $iNbInfo, $hDbSynchro)
	Local $hQuery, $sData
	; Toutes les lignes avant le $sDateSynchroData
	_SQlite_Query($hDbPrp, "SELECT HspDateSuppresssion, HspType, HspRefSynchro, HspDateCreation FROM HistoSuppression WHERE HspDateSuppresssion<='" & $sDateSynchroData & "';", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		ChangeIcone()
		If (($sData[1] = "T") And $bSynchronisationTexte) Or (($sData[1] = "I") And $bSynchronisationImage) Or ((StringLeft($sData[1], 1) = "S") And $bSynchronisationScript) Then
			_SQLite_Exec($hDbSynchro, "INSERT INTO HistoSuppression (HspDateSuppresssion, HspType, HspRefSynchro, HspDateCreation) VALUES ('" & _
										$sData[0] & "', '" & $sData[1] & "', '" & $sData[2] & "', '" & $sData[3] & "');")
			$iNbInfo += 1
		EndIf
	WEnd
	Return True
EndFunc


Func MAJHistoSupp()
	_SQLite_Exec($hDbPrp, "DELETE FROM HistoSuppression WHERE HspDateSuppresssion<='" & $sDateSynchroData & "';")
	Return True
EndFunc


Func OuvrirConnexionFTP()
	Local $s, $sMes = "Vrifier les paramtres de connexion dans vos prfrences."
	;----- _FTP_Open
	ChangeIcone()
	$hFTP = _FTP_Open($scAppliTitreGeneral)
	If $hFTP = 0 Then
		SynchroTrace("Erreur sur _FTP_Open", "", True, True)
		Return False
	EndIf
	;----- _FTP_Connect
	ChangeIcone()
	If $sSynchroMotPasseCrypte <> "" Then
		$IdFTP = _FTP_Connect($hFTP, $sSynchroServeur, $sSynchroUtilisateur, _StringEncrypt(0, $sSynchroMotPasseCrypte, $scCryptCle))
	Else
		$IdFTP = _FTP_Connect($hFTP, $sSynchroServeur, $sSynchroUtilisateur, "")
	EndIf
	If $IdFTP = 0 Then
		SynchroTrace("Connexion internet impossible - " & $sMes, "Connexion FTP impossible", True, False)
		Return False
	EndIf
	;----- Verif du dossier principal distant
	ChangeIcone()
	$s = _FTP_DirGetCurrent($IdFTP)
	If @error <> 0 Then
		SynchroTrace("Connexion FTP OK mais l'accs au dossier racine pose problme." & @CRLF & $sMes, "Dossier FTP inaccessible", True, True)
		Return False
	EndIf
	_FTP_DirSetCurrent($IdFTP, $sSynchroDossierServeur)
	If @error <> 0 Then
		SynchroTrace("Connexion FTP OK mais le dossier distant '" & $sSynchroDossierServeur & "' n'est pas accessible." & @CRLF & $sMes, "Dossier FTP inaccessible", True, True)
		Return False
	EndIf
	;----- Verif du dossier Machine
	ChangeIcone()
	_FTP_DirSetCurrent($IdFTP, $sSynchroDossierServeur & $sSynchroNomMachine)
	If @error <> 0 Then
		_FTP_DirCreate($IdFTP, $sSynchroDossierServeur & $sSynchroNomMachine)
		If @error <> 0 Then
			SynchroTrace("Connexion FTP OK mais le dossier propre  votre machine '" & $sSynchroDossierServeur & "' ne peut pas tre cr." & @CRLF & $sMes, "Dossier FTP inaccessible", True, True)
			Return False
		EndIf
	EndIf
	;----- Retour au dossier racine
	ChangeIcone()
	_FTP_DirSetCurrent($IdFTP, $s)
	;
	Return True
EndFunc


Func FermerConnexionFTP()
	ChangeIcone()
	If _FTP_Close($hFTP) <> 1 Then
		SynchroTrace("Erreur sur _FTP_Close", "", False, False)
		Return
	EndIf
EndFunc


Func ConnexionInternetOK()
	ChangeIcone()
	If Ping("www.google.com", 5000) = 0 Then
		SynchroTrace("Connexion internet indisponible", "", True, False)
		Return False
	Else
		Return True
	EndIf
EndFunc


Func SupportAccessible()
	Local $s, $i
	$sSynchroSupportLocal = ""
	For $i = 1 To $sSynchroSupportLocalListe[0]
		ChangeIcone()
		$s = _InfoNomFichier($sSynchroSupportLocalListe[$i], 8) ; Le drive
		; Drive OK ?
		If DriveStatus($s) = "READY" Then
			$sSynchroSupportLocal = $sSynchroSupportLocalListe[$i]
			ExitLoop
		EndIf
	Next
	If $sSynchroSupportLocal = "" Then
		If $sSynchroSupportLocalListe[0] = 1 Then
			SynchroTrace("Le support local " & $s & " n'est pas accessible", "Support local inaccessible", True, False)
		Else
			SynchroTrace("Les " & $sSynchroSupportLocalListe[0] & " supports locaux possibles ne sont pas accessibles", "Support local inaccessible", True, False)
		EndIf
		Return False
	EndIf
	; Rpertoire existant ?
	If Not _RepertoireExistant($sSynchroSupportLocal) Then
		If DirCreate($sSynchroSupportLocal) <> 1 Then
			SynchroTrace("Le support local " & $s & " est accessible mais le dossier " & $sSynchroSupportLocal & " ne peut pas tre cr", "Problme sur le support local", True, True)
			Return False
		EndIf
	EndIf
	If Not _RepertoireExistant($sSynchroSupportLocal) Then
		SynchroTrace("Le support local " & $s & " est accessible mais le dossier " & $sSynchroSupportLocal & " ne peut pas tre cr", "Problme sur le support local", True, True)
		Return False
	EndIf
	If StringRight($sSynchroSupportLocal, 1) <> "\" Then $sSynchroSupportLocal &= "\"
	; Dossier de la machine existant
	If Not _RepertoireExistant($sSynchroSupportLocal & $sSynchroNomMachine) Then
		If DirCreate($sSynchroSupportLocal & $sSynchroNomMachine) <> 1 Then
			SynchroTrace("Le support local " & $s & " est accessible mais le dossier " & $sSynchroSupportLocal & $sSynchroNomMachine & " ne peut pas tre cr", "Problme sur le support local", True, True)
			Return False
		EndIf
	EndIf
	;
	Return True
EndFunc


Func ListeAutresMachines()
	Local $sListeMachines, $sListeAutresMachines, $iDossier, $iAutreDossier, $sDossier
	; Liste des autres machines
	If $sSynchronisation = "S" Then ; Serveur
		$sListeMachines = ListeFichiersDossierDistant($IdFTP, $sSynchroDossierServeur, "D")
	Else ; support local
		$sListeMachines = _FileListToArray($sSynchroSupportLocal, "*.", 2)
		If $sListeMachines = 0 Then
			Dim $sListeMachines[1]
			$sListeMachines[0] = 0
		EndIf
	EndIf
	Dim $sListeAutresMachines[$sListeMachines[0] + 1]
	For $iDossier = 1 To $sListeMachines[0]
		$sDossier = $sListeMachines[$iDossier]
		If $sDossier = $sSynchroNomMachine Then ContinueLoop ; on ne prend pas le propre dossier de la machine en cours
		If StringLen($sDossier) > $iSynchroLongeurNomMachine Then ContinueLoop
		$iAutreDossier += 1
		$sListeAutresMachines[$iAutreDossier] = $sDossier
	Next
	$sListeAutresMachines[0] = $iAutreDossier
	Return $sListeAutresMachines
EndFunc


Func EcritureLog()
	Local $sMess, $hFicFlag
	Switch $iNbInfoEnvoye
		Case -1
			; Rien  faire dans ce cas
		Case 0
			Switch $sSynchronisation ; Type de synchronisation
				Case "S" ; Serveur
					$sMess = "Pas de donnes  envoyer. "
				Case "L" ; support local
					$sMess = "Pas de donnes  placer sur le support local. "
				Case Else
			EndSwitch
		Case Else
			Switch $sSynchronisation ; Type de synchronisation
				Case "S" ; Serveur
					$sMess = "Fichier de synchronisation dpos sur le serveur. "
				Case "L" ; support local
					$sMess = "Fichier de synchronisation dpos sur le support local. "
				Case Else
			EndSwitch
	EndSwitch
	If $sMess <> "" Then
		Switch $iNbFichierRecu
			Case -1
			Case 0
				Switch $sSynchronisation ; Type de synchronisation
					Case "S" ; Serveur
						$sMess &= "Aucune nouvelle donne (d'autres machines) prsente sur le serveur."
					Case "L" ; support local
						$sMess &= "Aucune nouvelle donne (d'autres machines) prsente sur le support local."
					Case Else
				EndSwitch
			Case 1
				Switch $sSynchronisation ; Type de synchronisation
					Case "S" ; Serveur
						$sMess &= "Un fichier trait depuis le serveur : "
					Case "L" ; support local
						$sMess &= "Un fichier trait depuis le support local : "
					Case Else
				EndSwitch
			Case Else
				Switch $sSynchronisation ; Type de synchronisation
					Case "S" ; Serveur
						$sMess &= $iNbFichierRecu & " fichiers traits depuis le serveur : "
					Case "L" ; support local
						$sMess &= $iNbFichierRecu & " fichiers traits depuis le support local : "
					Case Else
				EndSwitch
		EndSwitch
		; Ajouter $iNbLigneTexteRecu & $iNbLigneFavorisRecu & $iNbLigneImageRecu & $iNbLigneScriptRecu
		If $iNbFichierRecu > 0 Then
			Switch $iNbLigneTexteRecu
				Case 0
					$sMess &= "Aucun texte reu, "
				Case 1
					$sMess &= "Un texte reu, "
				Case Else
					$sMess &= $iNbLigneTexteRecu & " textes reus, "
			EndSwitch
			If $iNbLigneTexteRecu > 0 Then
				$hFicFlag = FileOpen($scReafFicherTApresSynchro, 2)
				If $hFicFlag <> -1 Then
					FileWriteLine($hFicFlag, $sDateSynchroData)
					FileClose($hFicFlag)
				EndIf
			EndIf
			Switch $iNbLigneFavorisRecu
				Case 0
					$sMess &= "aucun favoris reu, "
				Case 1
					$sMess &= "un favoris reu, "
				Case Else
					$sMess &= $iNbLigneFavorisRecu & " favoris reus, "
			EndSwitch
			If $iNbLigneFavorisRecu > 0 Then
				$hFicFlag = FileOpen($scReafFicherFApresSynchro, 2)
				If $hFicFlag <> -1 Then
					FileWriteLine($hFicFlag, $sDateSynchroData)
					FileClose($hFicFlag)
				EndIf
			EndIf
			Switch $iNbLigneImageRecu
				Case 0
					$sMess &= "aucune image reue, "
				Case 1
					$sMess &= "une image reue, "
				Case Else
					$sMess &= $iNbLigneImageRecu & " images reues, "
			EndSwitch
			If $iNbLigneImageRecu > 0 Then
				$hFicFlag = FileOpen($scReafFicherIApresSynchro, 2)
				If $hFicFlag <> -1 Then
					FileWriteLine($hFicFlag, $sDateSynchroData)
					FileClose($hFicFlag)
				EndIf
			EndIf
			Switch $iNbLigneScriptRecu
				Case 0
					$sMess &= "aucun scripting reu."
				Case 1
					$sMess &= "un scripting reu."
				Case Else
					$sMess &= $iNbLigneScriptRecu & " scriptings reus."
			EndSwitch
		EndIf
		SynchroTrace("Rsultat de la synchronisation : " & $sMess, "Synchronisation OK", False, False)
	EndIf
EndFunc


Func AfficherFichierLog()
	If Not FileExists($scFicLog) Then
		MsgBox(4160, $scMsgInfo, "Fichier de suivi non disponible (" & $scFicLog & ")")
	Else
		GUISetCursor(15, 1) ; Curseur WAIT
		ShellExecute($scFicLog)
		GUISetCursor(2) ; Curseur Classique
	EndIf
EndFunc

; OUT 1=Synchronisation  faire
Func EcranModif($bEnSortie)
	Local $nMsg, $iMin = 0, $iHeure = 0, $iJour = 0, $i, $iRetour = 0
	; Calcul de Min, Heure & Jour
	$i = Ceiling(_DiffDateMilliSecondes(_DateHeureJour(3), DbParamLireTexte("SynchroProchaine", "")) / 1000 / 60) ; la diffrence en minutes
	If $i > 0 Then
		$iJour = Floor($i / 60 / 24)
		$i -= $iJour * 60 * 24
		$iHeure = Floor($i / 60)
		$iMin = $i - ($iHeure * 60)
	EndIf
	; Prparation de l'interface
	Local Const $sTitreGroupeModif = " Modification de la prochaine synchronisation ClipSpirit "
	Local $sDerRecept = DbParamLireTexte("SynchroDateDernierSynchroRecu", "") ; Format AAAAMMJJHHMMSS
	If $sDerRecept = "" Then
		$sDerRecept = "Jamais"
	Else
		$sDerRecept = _TransformeDate($sDerRecept, 2, 1)
	EndIf
	Local Const $sDerTexte = DbParamLireTexte("SynchroDateDernierSynchroEnvoyeTexte", "")
	Local Const $sDerImage = DbParamLireTexte("SynchroDateDernierSynchroEnvoyeImage", "")
	Local Const $sDerScript = DbParamLireTexte("SynchroDateDernierSynchroEnvoyeScript", "")
	Local $sDerEnvoi = $sDerScript ; Format AAAA-MM-JJ HH:MM:SS.SSS
	If $sDerTexte > $sDerImage Then
		If $sDerTexte > $sDerScript Then $sDerEnvoi = $sDerTexte
	Else
		If $sDerImage > $sDerScript Then $sDerEnvoi = $sDerImage
	EndIf
	If $sDerEnvoi = "" Then
		$sDerEnvoi = "Jamais"
	Else
		$sDerEnvoi = _TransformeDate($sDerEnvoi, 1, 1)
	EndIf
	; Interface
	Local $FormClipSpiritSynchro = GUICreate("", 481, 297, -1, -1, BitOR($WS_POPUP,$WS_BORDER), 0)
	Local $ButtonLancer = GUICtrlCreateButton("Lancer la synchronisation maintenant", 131, 259, 219, 25, $WS_GROUP)
	Local $GroupInfo = GUICtrlCreateGroup(" Informations ", 8, 44, 465, 75)
	Local $LabelDerRecept = GUICtrlCreateLabel("Dernire rception de donnes", 24, 68, 156, 17)
	Local $LabelDerEnvoi = GUICtrlCreateLabel("Dernier envoi de donnes", 24, 92, 156, 17)
	Local $InputDerRecept = GUICtrlCreateInput($sDerRecept, 200, 64, 121, 21)
	GUICtrlSetState(-1, $GUI_DISABLE)
	Local $InputDerEnvoi = GUICtrlCreateInput($sDerEnvoi, 200, 88, 121, 21)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Local $GroupModif = GUICtrlCreateGroup($sTitreGroupeModif, 8, 129, 465, 121)
	Local $Radio1 = GUICtrlCreateRadio("Arrter la synchronisation jusqu'au prochain redmarrage de ClipSpirit", 24, 153, 377, 17)
	Local $Radio2 = GUICtrlCreateRadio("Ne plus utiliser la synchronisation - Elle pourra tre relance en modifiant vos prfrences", 24, 185, 441, 17)
	Local $Radio3 = GUICtrlCreateRadio("Forcer la prochaine synchronisation dans", 24, 217, 209, 17)
	Local $Input1 = GUICtrlCreateInput("", 240, 216, 25, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 3)
	Local $Label1 = GUICtrlCreateLabel("jour(s)", 271, 219, 32, 17)
	Local $Input2 = GUICtrlCreateInput("", 311, 216, 20, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 3)
	Local $Label2 = GUICtrlCreateLabel("heure(s)", 336, 219, 42, 17)
	Local $Input3 = GUICtrlCreateInput("", 388, 216, 20, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 3)
	Local $Label3 = GUICtrlCreateLabel("minute(s)", 415, 219, 46, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Local $ButtonModifier = GUICtrlCreateButton("Valider", 383, 259, 75, 25, $WS_GROUP)
	Local $ButtonFicSuivi = GUICtrlCreateButton("Voir le suivi", 24, 259, 75, 25, $WS_GROUP)
	Local $LabelTitre = GUICtrlCreateLabel("ClipSpirit - Synchronisation", 8, 16, 465, 17, $SS_CENTER)
	GUICtrlSetFont(-1, 11, 800, 0, "MS Sans Serif")
	GUISetState(@SW_SHOW)
	;
	GUICtrlSetState($Radio3, $GUI_CHECKED)
	GUICtrlSetData($Input1, $iJour)
	GUICtrlSetData($Input2, $iHeure)
	GUICtrlSetData($Input3, $iMin)
	GUISetState(@SW_SHOW)
	WinSetOnTop("", $sTitreGroupeModif, 1)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $ButtonFicSuivi
				AfficherFichierLog()
			Case $ButtonLancer
				$iRetour = 1
				ExitLoop
			Case $ButtonModifier
				Select
					Case GUICtrlRead($Radio1) = $GUI_CHECKED ; Arrter la synchronisation jusqu'au prochain redmarrage de ClipSpirit
						FichierNextSynchro("", False)
					Case GUICtrlRead($Radio2) = $GUI_CHECKED ; Ne plus utiliser la synchronisation - Elle pourra tre relance en modifiant les prfrences
						FichierNextSynchro("")
					Case GUICtrlRead($Radio3) = $GUI_CHECKED ; Forcer la prochaine synchro dans x minutes
						FichierNextSynchro(_AjouterDate(_DateHeureJour(3), ((Number(GUICtrlRead($Input1)) * 60 * 24) + (Number(GUICtrlRead($Input2)) * 60) + Number(GUICtrlRead($Input3)))* 1000 * 60))
				EndSelect
				ExitLoop
		EndSwitch
		Sleep(30)
	WEnd
	GUISetState(@SW_HIDE, $FormClipSpiritSynchro)
	Return $iRetour
EndFunc


; $sNext = Date-Heure de la prochaine Synchro au format AAAA-MM-JJ HH:MM:SS(.SSS) OU vide pour stopper
Func FichierNextSynchro($sNext, $bMajDB = True)
	Local $hFic = FileOpen($scStopSynchro, 10)
	If $hFic <> -1 Then
		If $sNext <> "" Then
			FileWriteLine($hFic, $scTxtNextSynchro & $sNext)
		Else
			FileWriteLine($hFic, "")
		EndIf
		FileClose($hFic)
	EndIf
	If $bMajDB Then DbParamMAJTexte("SynchroProchaine", $sNext)
EndFunc


; ========== Fonctions secondaires ================================================================


;--------------------------------------------------------------------------------------------------
; Fonction listant les fichiers et/dossiers d'un rpertoire distant (hors les . et ..)
;
; IN  $IdFTP		   : Identifiant donn par _FTP_Connect()
;	  $sDossierDistant : Dossier distant
;	  $sFiltreDF	   : Filtre sur les lments  retourner ("F" = Que les fichiers, "D" = Que les dossiers, "" = Tout)
;
; OUT Tableau : [0] : Donne le nombre d'lments
;				[1] : Nom du premier lment
;				[2] : Nom du second lment
;				...
;--------------------------------------------------------------------------------------------------
Func ListeFichiersDossierDistant($IdFTP, $sDossierDistant, $sFiltreDF)
	Local $hNext, $aInfo, $sType
	Local $sListe[1]
	$sListe[0] = 0
	$aInfo = _FTP_FindFileFirst($IdFTP, $sDossierDistant, $hNext)
	While @error = 0
		ChangeIcone()
		$sType = "F"
		If BitAND($aInfo[1], 0x00000010) Then $sType = "D"
		If ($sFiltreDF = $sType) And ($aInfo[10] <> ".") And ($aInfo[10] <> "..") Then
			$sListe[0] += 1
			ReDim $sListe[$sListe[0] + 1]
			$sListe[$sListe[0]] = $aInfo[10]
		EndIf
		$aInfo = _FTP_FindFileNext($hNext)
	WEnd
	_FTP_FindFileClose($hNext)
	Return $sListe
EndFunc


Func SynchroTrace($sTexteLong, $sTexteCourt, $bMajProchaineSynchro, $bAfficherMsgBox)
	Local $hFicLog = FileOpen($scFicLog, 1)
	If $hFicLog = -1 Then
		MsgBox(4112, $scMsgErreur, "Une erreur s'est produite dans le module de Synchronisation." & @CRLF & $sTexteLong & @CRLF & _
									"Mais cette erreur ne peut pas tre inscrite dans le fichier de log " & $scFicLog)
	Else
		FileWriteLine($hFicLog, _DateHeureJour(6) & " : " & $sTexteLong)
		FileClose($hFicLog)
	EndIf
	If $sTexteCourt = "" Then $sTexteCourt = $sTexteLong
	$sTrayTipLong = $sTexteLong
	$sTrayTipCourt = $sTexteCourt
	If $bMajProchaineSynchro Then DbMajProchaineRelanceSynchro()
	If $bAfficherMsgBox Then
		MsgBox(4112, $scMsgErreur, $sTexteLong)
		$iSynchroTempsIconeFin = 0 ; permet de ne pas afficher l'icne de fin et le message TrayTip
	EndIf
EndFunc


Func PrepaSortie($bOK)
	Local $iTimerFin = _Timer_Init()
	Local $idMsg, $s = "KO", $iOption = 3
	If $bOK Then
		$s = "OK"
		$iOption = 1
		FichierNextSynchro(_ProchaineSynchro(DbParamLireTexte("SynchroStep", ""), DbParamLireNum("SynchroStepRelance", 15)))
	Else
		FichierNextSynchro(_AjouterDate(_DateHeureJour(3), DbParamLireNum("SynchroStepRelance", 15) * 60 * 1000))
	EndIf
	If $iSynchroTempsIconeFin > 0 Then
		TraySetIcon(_Ressource($scAppliTitreGeneral & "-Synchro" & $s & ".ico"))
		If $iSynchroTempsMessageFin > 0 Then TrayTip($scAppliTitreGeneral, $sTrayTipCourt, $iSynchroTempsMessageFin, $iOption)
		While _Timer_Diff($iTimerFin) < $iSynchroTempsIconeFin
			$idMsg = TrayGetMsg()
			Switch $idMsg
				Case $hTrayModif
					EcranModif(True)
					ExitLoop
				Case $hTrayFicLog
					AfficherFichierLog()
				Case $hTrayQuitter
					ExitLoop
			EndSwitch
			Sleep(50)
		WEnd
	EndIf
	Sortie()
EndFunc

Func Sortie()
	; Fermeture de la bases de donnes principale
	_SQLite_Close($hDbPrp)
	_SQLite_Shutdown()
	; Sortie dfinitive du programe
	Exit
EndFunc


Func ChangeIcone()
	If _Timer_Diff($iIconesTimer) > 300 Then
		$iIconesTimer = _Timer_Init()
		TraySetIcon(_Ressource($scAppliTitreGeneral & "-Synchro" & $iIconesNum & ".ico"))
		$iIconesNum += 1
		If $iIconesNum > 4 Then $iIconesNum = 1
	EndIf
EndFunc


; Si le dossier de la machine en cours contient tous les fichiers de LOG des fichiers DB alors on peut supprimer (DB, DBC & LOG)
Func NettoyerPartage()
	Local $sListeFichier, $iFic, $sDebutNom, $i, $j, $iNb
	Local $iLongDebut = 14 + StringLen($scCorpsNomFicCree)
	Local $sListeAutresMachines = ListeAutresMachines()
	; S'il n'y pas d'autres dossiers d'autres machines alors on stoppe le traitement de nettoyage
	If $sListeAutresMachines[0] = 0 Then Return
	; Liste des fichiers
	If $sSynchronisation = "S" Then ; Serveur
		$sListeFichier = ListeFichiersDossierDistant($IdFTP, $sSynchroDossierServeur & $sSynchroNomMachine, "F")
	Else ; support local
		$sListeFichier = _FileListToArray($sSynchroSupportLocal & $sSynchroNomMachine, "*.*", 1)
		If $sListeFichier = 0 Then
			Dim $sListeFichier[1]
			$sListeFichier[0] = 0
		EndIf
	EndIf
	; Parcours des fichiers
	For $iFic = 1 To $sListeFichier[0]
		ChangeIcone()
		; Fichier Concern ? Date + Corps
		If Not StringIsDigit(StringLeft($sListeFichier[$iFic], 14)) Or StringMid($sListeFichier[$iFic], 15, StringLen($scCorpsNomFicCree)) <> $scCorpsNomFicCree Then ContinueLoop
		; Db, Dbc & LOG
		$sDebutNom = StringLeft($sListeFichier[$iFic], $iLongDebut)
		If (StringRight($sListeFichier[$iFic], 3) = ".db") Or (StringRight($sListeFichier[$iFic], 4) = ".dbc") Then
			$iNb = 0
			For $i = 1 To $sListeFichier[0]
				If (StringLeft($sListeFichier[$i], $iLongDebut) = $sDebutNom) And (StringRight($sListeFichier[$i], 4) = ".log") Then
					For $j = 1 To $sListeAutresMachines[0]
						If $sListeFichier[$i] = $sDebutNom & $sListeAutresMachines[$j] & ".log" Then
							$sListeFichier[$i] = ""
							$iNb += 1
							ExitLoop
						EndIf
					Next
				EndIf
			Next
			If $iNb = $sListeAutresMachines[0] Then
				SupprimerFichierLocalServeur($sListeFichier[$iFic])
				$sListeFichier[$iFic] = ""
				For $j = 1 To $sListeAutresMachines[0]
					SupprimerFichierLocalServeur($sDebutNom & $sListeAutresMachines[$j] & ".log")
				Next
			EndIf
		ElseIf StringRight($sListeFichier[$iFic], 4) = ".log" Then
			If (Not FichierLocalServeurExiste(StringLeft($sListeFichier[$iFic], $iLongDebut) & $sSynchroNomMachine & ".db")) And (Not FichierLocalServeurExiste(StringLeft($sListeFichier[$iFic], $iLongDebut) & $sSynchroNomMachine & ".dbc")) Then
				SupprimerFichierLocalServeur($sListeFichier[$iFic])
				$sListeFichier[$iFic] = ""
			EndIf
		EndIf
	Next
EndFunc


Func SupprimerFichierLocalServeur($sFichier)
	If $sSynchronisation = "S" Then ; Serveur
		Return (_FTP_FileDelete($IdFTP, $sSynchroDossierServeur & $sSynchroNomMachine & "/" & $sFichier) = 1)
	Else ; support local
		Return (FileDelete($sSynchroSupportLocal & $sSynchroNomMachine & "\" & $sFichier) = 1)
	EndIf
EndFunc


Func FichierLocalServeurExiste($sFichier)
	If $sSynchronisation = "S" Then ; Serveur
		Return (_FTP_FileGetSize($IdFTP, $sSynchroDossierServeur & $sSynchroNomMachine & "/" & $sFichier) > 0)
	Else ; support local
		Return (FileExists($sSynchroSupportLocal & $sSynchroNomMachine & "\" & $sFichier) = 1)
	EndIf
EndFunc


Func FlagHotKey()
	Local $hFic
	If Not FileExists($scReafHotKeyApresSynchro) Then
		$hFic = FileOpen($scReafHotKeyApresSynchro, 2)
		If $hFic <> -1 Then
			FileWriteLine($hFic, $sDateSynchroData)
			FileClose($hFic)
		EndIf
	EndIf
EndFunc