#cs -----------------------------------------------------------------------------------------------

	Module base de donnes Sqlite de ClipSpirit
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Janvier 2011 - Octobre 2011

	Liste des fonctions
	-------------------


#ce -----------------------------------------------------------------------------------------------

#include-once
#include <SQLite.au3>
#include <SQLite.dll.au3>
#include <GuiListView.au3>
#include <GuiImageList.au3>
#include <GDIPlus.au3>
#Include <Math.au3>
#include "ClipSpiritLib.au3"

AutoItSetOption("MustDeclareVars", 1)
; Le nom de la base de donnes
Global $sFicDB = $scAppliTitreGeneral
If Not @Compiled Then $sFicDB &= "Test"
Global $sFicDBComplet = @ScriptDir & "\" & $sFicDB & ".db"
; Le Handle de la base de donnes
Global $hDbPrp


;--------------------------------------------------------------------------------------------------
; Fonction d'ouverture de la base de donnes ClipSpirit
;
; IN  $sProgAppelant : Nom du programme appelant sous la forme xxxxx.exe ($scProgPrincipal, $scProgPreference, $scProgMAJ)
; OUT "" si un problme rencontr, Sinon le numro de version cours
;--------------------------------------------------------------------------------------------------
Func DbOuvrir($sProgAppelant)
	Local $dVerDB
	Local $bDbACreer = Not _FichierExistant($sFicDBComplet)
	; Si la base n'existe pas peut-on la crr ici ?
	If $bDbACreer And ($sProgAppelant <> $scProgPrincipal) Then
		MsgBox(4112, $scMsgErreur, "Vous devez dj lancer l'application principale '" & $scProgPrincipal & "' avant d'accder aux autres fonctionnalits") ; l'interface n'est pas cre, ne pas utiliser $Form...
		Return ""
	EndIf
	; Chargement de SQLite.dll
	_SQLite_Startup()
	If @error > 0 Then
		MsgBox(4112, $scMsgErreur, "SQLite.dll ne peut tre charg !") ; l'interface n'est pas cre, ne pas utiliser $Form...
		Return ""
	EndIf
	; Ouvrir la base
	$hDbPrp = _SQLite_Open($sFicDBComplet)
	If @error > 0 Then
		MsgBox(4112, $scMsgErreur, "La base de donnes ne peut tre charge !") ; l'interface n'est pas cre, ne pas utiliser $Form...
		Return ""
	EndIf
	; Eventuellement la crer
	If $bDbACreer Then DbCreerBase($hDbPrp)
	; Test de la version de DB
	$dVerDB = DbTPLireNum("Version")
	If Not @Compiled Then
		If $dVerDB = "" Then $dVerDB = "0.0"
	Else
		; Complter au format xx.YY
		If StringInStr($dVerDB, ".") = 0 Then $dVerDB &= ".00"
		$dVerDB &= StringRight(".00", 2 - StringLen($dVerDB) + StringInStr($dVerDB, "."))
		Switch $sProgAppelant
			Case $scProgPrincipal
				If (Number($dVerDB) > Number(_NumVerCourt($scVersion))) Then
					MsgBox(4112, $scMsgErreur, "La version (" & $dVerDB & ") de la base de donnes (" & $sFicDBComplet & ") n'est pas cohrente avec la version de l'application !") ; l'interface n'est pas cre, ne pas utiliser $Form...
					Return ""
				EndIf
				If (Number($dVerDB) < Number(_NumVerCourt($scVersion))) Then
					If Not _FichierExistant(@ScriptDir & "\" & $scProgMAJ) Then
						MsgBox(4112, $scMsgErreur, "Le programme de mise  jour des versions (" & $scProgMAJ & ") n'est pas trouv dans le dossier" & @CRLF & @ScriptDir & _
													@CRLF & "Rinstaller " & $scAppliTitreGeneral & ", en prservant nos donnes")
						Return ""
					Else
						If ShellExecute(@ScriptDir & "\" & $scProgMAJ, $scProgPrincipal, @ScriptDir) <> 1 Then
							MsgBox(4112, $scMsgErreur, "Le programme de mise  jour des versions (" & $scProgMAJ & ") ne peut pas tre excut dans le dossier" & @CRLF & _
														@ScriptDir & @CRLF & "Rinstaller " & $scAppliTitreGeneral & ", en prservant nos donnes")
							Return ""
						Else
							Exit ; Le programme de mise  jour a t lanc avec succes => son sort du programme appelant - ClipSpirit.exe
						EndIf
					EndIf
				EndIf
			Case $scProgSynchro, $scProgPreference
				If (Number($dVerDB) <> Number(_NumVerCourt($scVersion))) Then
					MsgBox(4112, $scMsgErreur, "Lancer le programme principal (ClipSpirit.exe) avant de faire une autre action")
					Return ""
				EndIf
			Case $scProgMAJ
				; Rien  faire
		EndSwitch
	EndIf
	; Sortie de la fonction
	Return $dVerDB
EndFunc


Func DbCreerBase($hDb, $sType = "")
	; Table Texte
	_SQLite_Exec($hDb, "CREATE TABLE Texte (PrpText TEXT, PrpTitre TEXT, PrpEstFavoris BOOLEAN DEFAULT (0), PrpProvenance TEXT, PrpCommentaire TEXT, PrpPlus TEXT, PrpDateCreation TIMESTAMP, PrpDateModification TIMESTAMP, PrpDateUtilisation TIMESTAMP, PrpDateClassement TIMESTAMP NOT NULL, PrpRefSynchro INTEGER NOT NULL, CONSTRAINT [] PRIMARY KEY (PrpDateClassement, PrpRefSynchro));")
	; Table Image
	_SQLite_Exec($hDb, "CREATE TABLE Image (ImgImage BLOB, ImgVignette BLOB, ImgTitre TEXT, ImgProvenance TEXT, ImgCommentaire TEXT, ImgDateCreation TIMESTAMP, ImgDateModification TIMESTAMP, ImgDateUtilisation TIMESTAMP, ImgDateClassement TIMESTAMP NOT NULL, ImgRefSynchro INTEGER NOT NULL, CONSTRAINT [] PRIMARY KEY (ImgDateClassement, ImgRefSynchro));")
	; Table Parametre
	_SQLite_Exec($hDb, "CREATE TABLE Parametre (PrmCle TEXT NOT NULL, PrmValNum DOUBLE, PrmValTexte TEXT, PrmValBoolean BOOLEAN DEFAULT (0), CONSTRAINT [] PRIMARY KEY (PrmCle));")
	; Table CodeEntete
	_SQLite_Exec($hDb, "CREATE TABLE CodeEntete (CEnRef INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, CEnType CHAR(1), CEnOrdre DOUBLE, CEnTitreCode TEXT, CEnTitreMenu TEXT, CEnCode TEXT, CEnTpsMaxExe INTEGER, CEnToucheActivation TEXT, CEnActif BOOLEAN DEFAULT (1), CEnDateCreation TIMESTAMP, CEnDateModification TIMESTAMP);")
	_SQLite_Exec($hDb, "CREATE UNIQUE INDEX CEn_Index_TypeOrdre ON CodeEntete (CEnType, CEnOrdre);")
	; Ajouter le script Automatique (vide)
	If $sType <> "Synchro" Then _
		_SQLite_Exec($hDb, "INSERT INTO CodeEntete (CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnActif, CEnTpsMaxExe, CEnDateCreation) VALUES ('A', 1, 'Le script auto', '', 0, 30, '" & _DateHeureJour(3) & "');")
	; Table CodeDetail
	_SQLite_Exec($hDb, "CREATE TABLE CodeDetail (CDeRefEntete INTEGER NOT NULL, CDeOrdre DOUBLE NOT NULL, CDeType TEXT, CDeParam1 TEXT, CDeParam2 TEXT, CDeParam3 TEXT, CDeParam4 TEXT, CDeParam5 TEXT, CONSTRAINT [] PRIMARY KEY (CDeRefEntete, CDeOrdre));")
	; Table HistoSuppression
	_SQLite_Exec($hDb, "CREATE TABLE HistoSuppression (HspDateSuppresssion TIMESTAMP, HspType Texte, HspRefSynchro INTEGER, HspDateCreation TIMESTAMP);")
	; Info de la table Parametre (la fontion DbTPInsererNum ne peut pas tre appele car elle ne passe la rfrence de la base $hDb)
	_SQLite_Exec($hDb, "INSERT INTO Parametre (PrmCle, PrmValNum) VALUES ('Version', '" & _NumVerCourt($scVersion) & "');")
EndFunc


Func DbPeuplerListViewTexte($ListView, $iNbMax, $ListViewTexte, $ListViewFavoris, $bSynchronisation)
	Local $hQuery, $sData, $iNbLigne = 0, $IdOut = -1, $vRetour, $bLigne = False
	If ($ListView <> $ListViewTexte) Or ($iNbMax < 0) Then $iNbMax = 0
	_GUICtrlListView_BeginUpdate($ListView)
	_GUICtrlListView_DeleteAllItems($ListView)
	_SQlite_Query($hDbPrp, "SELECT PrpTitre, ROWID, PrpPlus FROM Texte WHERE PrpEstFavoris='" & Number($ListView = $ListViewFavoris) & "' ORDER BY PrpDateClassement DESC, PrpRefSynchro DESC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		$bLigne = True
		If $iNbMax <> 0 Then
			$iNbLigne += 1
			If $iNbLigne > $iNbMax Then
				$IdOut = $sData[1]
				ExitLoop
			EndIf
		EndIf
		GUICtrlCreateListViewItem($sData[0] & $cCarSep & $sData[1], $ListView)
		_CouleurTexteEtFond(-1, _LireValParamPlus($sData[2], "BkC", $sCouleurDef))
	WEnd
	_SQLite_QueryFinalize($hQuery)
	_GUICtrlListView_EndUpdate($ListView)
	If Not $bLigne Then _GUICtrlListView_RedrawItems($ListView, 0, 0) ; Ligne ajoute car si la synchro supprime toutes les lignes et que la liste n'avait pas t affiche avant la liste initiale reste en visu !
	_GUICtrlListView_SetColumnWidth($ListView, 1, 0)
	; Suppression de l'ventuel fichier de synchronisation
	If $ListView = $ListViewFavoris Then
		FileDelete($scReafFicherFApresSynchro)
	Else
		FileDelete($scReafFicherTApresSynchro)
	EndIf
	If $IdOut >=0 Then
		$vRetour = DbDateClassementEtRefSynchro($IdOut)
		If $vRetour[0] <> -1 Then
			_SQlite_Query($hDbPrp, "SELECT ROWID, PrpDateCreation, PrpDateClassement, PrpRefSynchro, PrpPlus FROM Texte WHERE PrpEstFavoris='0' AND PrpDateClassement<='" & _
									$vRetour[0] & "' ORDER BY PrpDateClassement DESC, PrpRefSynchro DESC;", $hQuery)
			While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
				; Tester si PrpDateClassement = $vRetour[0] alors PrpRefSynchro doit tre <= $vRetour[1]
				If ($sData[2] < $vRetour[0]) Or (Number($sData[3]) <= Number($vRetour[1])) Then
					; suppression du raccourci
					If _LireValParamPlus($sData[4], "HKy", "") <> "" Then _SupprimerHotKeyTxt($vRetour[0])
					If _SQLite_Exec($hDbPrp, "DELETE FROM Texte WHERE ROWID='" & $sData[0] & "';") = $SQLITE_OK Then
						If $bSynchronisation Then DbAjoutHistoSuppr("T", $sData[1], $sData[3])
					EndIf
				EndIf
			WEnd
		EndIf
	EndIf
EndFunc


Func DbPeuplerListViewImage($ListView, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisation, $bInit = False)
	Local $hImageList, $hQuery, $sData, $vRetour, $iNbLigne = 0, $IdOut = -1, $bLigne = False
	Local $fOpen, $hBmp1, $hBmp2, $hBitmap, $hGraphic, $hImage, $iLargeur, $iHauteur
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($ListView))
	If $iNbMaxItemImage = 0 Then Return ; option de non gestion des images
	If IsPtr($hImageList) Then _GUIImageList_Destroy($hImageList)
	$hImageList = _GUiImageList_Create($iVignetteLargeur, $iVignetteHauteur, 5, 3)
	_GUICtrlListView_SetImageList($Listview, $hImageList, 0)
	_SQlite_Query($hDbPrp, "SELECT ImgVignette, ImgTitre, ROWID FROM Image ORDER BY ImgDateClassement DESC, ImgRefSynchro DESC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		$bLigne = True
		$iNbLigne += 1
		; Plus de $iNbMaxItemImage items ?
		If $iNbMaxItemImage <> 0 Then
			If $iNbLigne > $iNbMaxItemImage Then
				$IdOut = $sData[2]
				ExitLoop
			EndIf
		EndIf
		; Cration de la vignette
		$fOpen = FileOpen($scNomCompletTempVignette, 2)
		FileWrite($fOpen, Binary($sData[0]))
		FileClose($fOpen)
		; Affichage de la vignette dans la listview
		_GDIPlus_Startup()
		$hImage = _GDIPlus_ImageLoadFromFile($scNomCompletTempVignette)
		$iLargeur = _GDIPlus_ImageGetWidth($hImage)
		$iHauteur = _GDIPlus_ImageGetHeight($hImage)
		$hBmp1 = _WinAPI_CreateBitmap($iVignetteLargeur, $iVignetteHauteur, 1, 32)
		$hBitmap = _GDIPlus_BitmapCreateFromHBITMAP($hBmp1)
		$hGraphic = _GDIPlus_ImageGetGraphicsContext($hBitmap)
		_WinAPI_DeleteObject($hBmp1)
		_GDIPlus_GraphicsClear($hGraphic, -2500129)
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hImage, _Max(($iVignetteLargeur - $iLargeur) / 2, 0), _Max(($iVignetteHauteur - $iHauteur) / 2, 0), $iLargeur, $iHauteur)
		_GDIPlus_ImageDispose($hImage)
		_GDIPlus_GraphicsDispose($hGraphic)
		$hBmp2 = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hBitmap)
		_GDIPlus_BitmapDispose($hBitmap)
		_GDIPlus_Shutdown()
		_GUiImageList_Add($hImageList, $hBmp2)
		_WinAPI_DeleteObject($hBmp2)
		_GUICtrlListView_AddItem($Listview, $sData[1], $iNbLigne - 1)
		_GUICtrlListView_SetItemImage($Listview, $iNbLigne - 1, $iNbLigne - 1)
		If $bInit Then ExitLoop
	WEnd
	_SQLite_QueryFinalize($hQuery)
	If Not $bLigne Then _GUICtrlListView_RedrawItems($ListView, 0, 0) ; Ligne ajoute car si la synchro supprime toutes les lignes et que la liste n'avait pas t affiche avant la liste initiale reste en visu !
	FileDelete($scNomCompletTempVignette)
	FileDelete($scReafFicherIApresSynchro) ; Suppression de l'ventuel fichier de synchronisation
	If $IdOut >=0 Then
		$vRetour = DbDateClassementEtRefSynchro($IdOut, True)
		If $vRetour[0] <> -1 Then
			_SQlite_Query($hDbPrp, "SELECT ROWID, ImgDateCreation, ImgDateClassement, ImgRefSynchro FROM Image WHERE ImgDateClassement<='" & $vRetour[0] & _
										"' ORDER BY ImgDateClassement DESC, ImgRefSynchro DESC;", $hQuery)
			While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
				; Tester si ImgDateClassement = $vRetour[0] alors ImgRefSynchro doit tre <= $vRetour[1]
				If ($sData[2] < $vRetour[0]) Or (Number($sData[3]) <= Number($vRetour[1])) Then
					If _SQLite_Exec($hDbPrp, "DELETE FROM Image WHERE ROWID='" & $sData[0] & "';") = $SQLITE_OK Then
						If $bSynchronisation Then DbAjoutHistoSuppr("I", $sData[1], $sData[2])
					EndIf
				EndIf
			WEnd
		EndIf
	EndIf
EndFunc


Func DbParamLireBoolean($sCle, $bDefaut)
	Local $iDefaut = 0
	If $bDefaut Then $iDefaut = 1
	Return DbTPLireBoolean("ParamB-" & $sCle, $iDefaut)
EndFunc
Func DbTPLireBoolean($sCle, $iDefaut = -1) ; $iDefaut : valeur par dfaut, si pas en base : 0=False, 1=True, -1=doit tre en base
	Local $sData
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT PrmValBoolean FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return ($sData[0] = 1)
	Else
		If $iDefaut = -1 Then
			MsgBox(4112, $scMsgErreur, "Le paramtre '" & $sCle & "' n'est pas trouv dans " & $sFicDBComplet)
			Return -1
		Else
			DbTPInsererBoolean($sCle, $iDefaut)
			Return ($iDefaut = 1)
		EndIf
	EndIf
EndFunc
Func DbTPInsererBoolean($sCle, $bVal)
	_SQLite_Exec($hDbPrp, "INSERT INTO Parametre (PrmCle, PrmValBoolean) VALUES ('" & $sCle & "', '" & Number($bVal) & "');")
EndFunc
Func DbParamMAJBoolean($sCle, $bVal)
	Return DbTPMAJBoolean("ParamB-" & $sCle, $bVal)
EndFunc
Func DbTPMAJBoolean($sCle, $bVal)
	If Number(DbTPLireBoolean($sCle, -1)) <> - 1 Then _
		Return (_SQLite_Exec($hDbPrp, "UPDATE Parametre SET PrmValBoolean='" & Number($bVal) & "' WHERE PrmCle='" & $sCle & "';") = $SQLITE_OK)
EndFunc


Func DbParamLireNum($sCle, $dDefaut)
	Return DbTPLireNum("ParamN-" & $sCle, $dDefaut)
EndFunc
Func DbTPLireNum($sCle, $dDefaut = Default) ; si $dDefaut= Default => doit tre en base
	Local $sData
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT PrmValNum FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return Number($sData[0])
	Else
		If $dDefaut = Default Then
			MsgBox(4112, $scMsgErreur, "Le paramtre '" & $sCle & "' n'est pas trouv dans " & $sFicDBComplet)
			Return 0
		Else
			DbTPInsererNum($sCle, $dDefaut)
			Return $dDefaut
		EndIf
	EndIf
EndFunc
Func DbTPInsererNum($sCle, $dVal)
	_SQLite_Exec($hDbPrp, "INSERT INTO Parametre (PrmCle, PrmValNum) VALUES ('" & $sCle & "', '" & $dVal & "');")
EndFunc
Func DbTPMAJNum($sCle, $dVal)
	Return (_SQLite_Exec($hDbPrp, "UPDATE Parametre SET PrmValNum='" & $dVal & "' WHERE PrmCle='" & $sCle & "';") = $SQLITE_OK)
EndFunc
Func DbParamMAJNum($sCle, $dVal)
	 Return DbTPMAJNum("ParamN-" & $sCle, $dVal)
EndFunc


Func DbParamLireTexte($sCle, $sDefaut)
	Return DbTPLireTexte("ParamT-" & $sCle, $sDefaut)
EndFunc
Func DbTPLireTexte($sCle, $sDefaut = Default) ; si $sDefaut= Default => doit tre en base
	Local $sData
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT PrmValTexte FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return $sData[0]
	Else
		If $sDefaut = Default Then
			MsgBox(4112, $scMsgErreur, "Le paramtre texte '" & $sCle & "' n'est pas trouv dans " & $sFicDBComplet)
			Return ""
		Else
			DbTPInsererTexte($sCle, $sDefaut)
			Return $sDefaut
		EndIf
	EndIf
EndFunc
Func DbTPInsererTexte($sCle, $sVal)
	Return (_SQLite_Exec($hDbPrp, "INSERT INTO Parametre (PrmCle, PrmValTexte) VALUES ('" & $sCle & "', '" & $sVal & "');") = $SQLITE_OK)
EndFunc
Func DbParamMAJTexte($sCle, $sVal)
	 Return DbTPMAJTexte("ParamT-" & $sCle, $sVal)
EndFunc
Func DbTPMAJTexte($sCle, $sVal)
	Local $sData
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT PrmValTexte FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return (_SQLite_Exec($hDbPrp, "UPDATE Parametre SET PrmValTexte='" & $sVal & "' WHERE PrmCle='" & $sCle & "';") = $SQLITE_OK)
	Else
		Return DbTPInsererTexte($sCle, $sVal)
	EndIf
EndFunc


; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
Func DbItemTexteLireComplet($iID, $Form, $bAfficherErreur = True)
	Local $hQuery, $sData[11]
	_SQlite_Query($hDbPrp, "SELECT PrpText, PrpTitre, PrpProvenance, PrpCommentaire, PrpDateCreation, PrpDateModification, PrpDateClassement, PrpEstFavoris, PrpDateUtilisation, PrpPlus, PrpRefSynchro FROM Texte WHERE ROWID='" & $iID & "';", $hQuery)
	If _SQLite_FetchData($hQuery, $sData) <> $SQLITE_OK Then
		ReDim $sData[11]
		$sData[0] = $scPerdu
		MsgBox(4160, $scMsgInfo, "Cet item n'est plus dans la liste initiale", 0, $Form)
	EndIf
	_SQLite_QueryFinalize($hQuery)
	Return $sData
EndFunc


Func DbItemLireUniquementTexte($iID)
	Local $hQuery, $sData[1]
	_SQlite_Query($hDbPrp, "SELECT PrpText FROM Texte WHERE ROWID='" & $iID & "';", $hQuery)
	If _SQLite_FetchData($hQuery, $sData) <> $SQLITE_OK Then
		ReDim $sData[1]
		$sData[0] = $scPerdu
	EndIf
	_SQLite_QueryFinalize($hQuery)
	Return $sData[0]
EndFunc


Func DbPlacerItemEnPremier($iID, $bImage = False)
	Local $sData, $sDJ = _DateHeureJour(3)
	If $bImage Then
		If Not _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID FROM Image ORDER BY ImgDateClassement DESC, ImgRefSynchro DESC;", $sData) = $SQLITE_OK Then Return False
		If $sData[0] = $iID Then Return DbMAJDateUtilisation($iID, True)
		Return (_SQLite_Exec($hDbPrp, "UPDATE Image SET ImgDateClassement='" & $sDJ & "', ImgDateUtilisation='" & $sDJ  & "', ImgDateModification='" & _
										$sDJ & "' WHERE ROWID='" & $iID & "';") = $SQLITE_OK)
	Else
		If Not _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID FROM Texte ORDER BY PrpDateClassement DESC, PrpRefSynchro DESC;", $sData) = $SQLITE_OK Then Return False
		If $sData[0] = $iID Then Return DbMAJDateUtilisation($iID)
		Return (_SQLite_Exec($hDbPrp, "UPDATE Texte SET PrpDateClassement='" & $sDJ & "', PrpDateUtilisation='" & $sDJ  & "', PrpDateModification='" & _
										$sDJ & "' WHERE ROWID='" & $iID & "';") = $SQLITE_OK)
	EndIf
EndFunc


Func DbMAJDateUtilisation($iID, $bImage = False)
	If $bImage Then
		Return (_SQLite_Exec($hDbPrp, "UPDATE Image SET ImgDateUtilisation='" & _DateHeureJour(3) & "'  WHERE ROWID='" & $iID & "';") = $SQLITE_OK)
	Else
		Return (_SQLite_Exec($hDbPrp, "UPDATE Texte SET PrpDateUtilisation='" & _DateHeureJour(3) & "'  WHERE ROWID='" & $iID & "';") = $SQLITE_OK)
	EndIf
EndFunc


Func DbMAJDateClassement($iID, $sDateClassementNew)
	Return (_SQLite_Exec($hDbPrp, "UPDATE Texte SET PrpDateClassement='" & $sDateClassementNew & "', PrpDateModification='" & _DateHeureJour(3) & "' WHERE ROWID='" & $iID & "';") = $SQLITE_OK)
EndFunc


Func DbMAJItemTexte($iID, $sTitre, $sText, $sCommentaire, $sPlus)
	Return(_SQLite_Exec($hDbPrp, "UPDATE Texte SET PrpTitre='" & _Quote($sTitre) & "', PrpText='" & _Quote($sText) & "', PrpCommentaire='" & _Quote($sCommentaire) & _
									"', PrpPlus='" & _Quote($sPlus) & "', PrpDateModification='" & _DateHeureJour(3) & "' WHERE ROWID='" & $iID & "';") = $SQLITE_OK)
EndFunc


Func DbInsererNouveauTexte($sTexte, $sOwner, $bFavoris, $sTitre, $sPlus = "", $sCommentaire = "")
	Local $sDJ = _DateHeureJour(3), $iRefSynchro = Ceiling(Random($iRefSynchroMin, $iRefSynchroMax))
	_SQLite_Exec($hDbPrp, "INSERT INTO Texte (PrpText, PrpTitre, PrpEstFavoris, PrpProvenance, PrpPlus, PrpDateCreation, PrpDateUtilisation, PrpCommentaire, PrpDateClassement, PrpRefSynchro) VALUES " & _
							"('" & _Quote($sTexte) & "', '" & _Quote($sTitre) & "', '" & Number($bFavoris) & "', '" & _Quote($sOwner) & "', '" & _Quote($sPlus) & "', '" & $sDJ & _
							"', '" & $sDJ & "', '"  & _Quote($sCommentaire) &  "', '" & $sDJ & "', '" & $iRefSynchro & "');")
	Return DbIDDateClassementEtRefSynchro($sDJ, $iRefSynchro)
EndFunc


Func DbInsererNouvelleImage($sImage, $sVignette, $sTitre, $sOwner)
	Local $sDJ = _DateHeureJour(3), $iRefSynchro = Ceiling(Random($iRefSynchroMin, $iRefSynchroMax))
	_SQLite_Exec($hDbPrp, "INSERT INTO Image (ImgImage, ImgVignette, ImgTitre, ImgProvenance, ImgDateCreation, ImgDateUtilisation, ImgDateClassement, ImgRefSynchro) VALUES " & _
				"('" & $sImage & "', '" & $sVignette & "', '" & $sTitre & "', '" & _Quote($sOwner) & "', '" & $sDJ & "', '" & $sDJ &  "', '" & $sDJ & "', '" & $iRefSynchro & "');")
	Return DbIDDateClassementEtRefSynchro($sDJ, $iRefSynchro, True)
EndFunc


Func DbDeleteItem($iID, $bSynchronisation)
	Local $sData
	If $bSynchronisation Then
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT PrpDateCreation, PrpRefSynchro FROM Texte WHERE ROWID='" & $iID & "';", $sData) = $SQLITE_OK Then _
			DbAjoutHistoSuppr("T", $sData[0], $sData[1])
	EndIf
	Return(_SQLite_Exec($hDbPrp, "DELETE FROM Texte WHERE ROWID='" & $iID & "';") = $SQLITE_OK)
EndFunc


Func DbIDDateClassementEtRefSynchro($sDateClassement, $iRefSynchro, $bImage = False)
	Local $sData
	If $bImage Then
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID FROM Image WHERE ImgDateClassement='" & $sDateClassement & "' AND ImgRefSynchro='" & $iRefSynchro & "';", $sData) = $SQLITE_OK Then
			Return Number($sData[0])
		Else
			Return -1
		EndIf
	Else
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID FROM Texte WHERE PrpDateClassement='" & $sDateClassement & "' AND PrpRefSynchro='" & $iRefSynchro & "';", $sData) = $SQLITE_OK Then
			Return Number($sData[0])
		Else
			Return -1
		EndIf
	EndIf
EndFunc


Func DbDateClassementEtRefSynchro($iID, $bImage = False)
	Local $sData, $Erreur[2] = [-1, -1]
	If $bImage Then
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT ImgDateClassement, ImgRefSynchro FROM Image WHERE ROWID='" & $iID & "';", $sData) = $SQLITE_OK Then
			Return $sData
		Else
			Return $Erreur
		EndIf
	Else
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT PrpDateClassement, PrpRefSynchro FROM Texte WHERE ROWID='" & $iID & "';", $sData) = $SQLITE_OK Then
			Return $sData
		Else
			Return $Erreur
		EndIf
	EndIf
EndFunc


Func DbClassementAvant($sDateClassementApres, $bFavoris)
	Local $hQuery, $sData
	_SQlite_Query($hDbPrp, "SELECT PrpDateClassement FROM Texte WHERE PrpDateClassement>'" & $sDateClassementApres & "' AND PrpEstFavoris='" & Number($bFavoris) & "' ORDER BY PrpDateClassement ASC, PrpRefSynchro ASC;", $hQuery)
	If _SQLite_FetchData($hQuery, $sData) <> $SQLITE_OK Then
		ReDim $sData[1]
		$sData[0] = _DateHeureJour(3)
	EndIf
	_SQLite_QueryFinalize($hQuery)
	Return $sData[0]
EndFunc


Func DbIDDuTexte($sTexte, $bFavoris)
	Local $sData
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID FROM Texte WHERE PrpText='" & _Quote($sTexte) & "' AND PrpEstFavoris='" & Number($bFavoris) & "';", $sData) = $SQLITE_OK Then
		Return $sData[0]
	Else
		Return - 1
	EndIf
EndFunc


Func DbIDImage($sImage)
	Local $sData
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT ROWID FROM Image WHERE ImgImage='" & $sImage & "';", $sData) = $SQLITE_OK Then
		Return $sData[0]
	Else
		Return - 1
	EndIf
EndFunc


; 0=PrpText 1=PrpTitre 2=PrpProvenance 3=PrpCommentaire 4=PrpPlus
Func DbItemTexteLireDernier()
	Local $hQuery, $sData[5]
	_SQlite_Query($hDbPrp, "SELECT PrpText, PrpTitre, PrpProvenance, PrpCommentaire, PrpPlus FROM Texte ORDER BY PrpDateClassement DESC, PrpRefSynchro DESC;", $hQuery)
	_SQLite_FetchData($hQuery, $sData)
	_SQLite_QueryFinalize($hQuery)
	Return $sData
EndFunc


Func DbScriptListeMenu($sType)
	Local $sData, $hQuery, $iNb = 0, $sMenu[1][2]
	_SQlite_Query($hDbPrp, "SELECT CEnTitreMenu, CEnRef FROM CodeEntete WHERE CEnType='" & $sType & "' AND CEnActif=1 ORDER BY CEnOrdre;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		$iNb += 1
		ReDim $sMenu[$iNb + 1][2]
		$sMenu[$iNb][0] = $sData[0]
		$sMenu[$iNb][1] = $sData[1]
	WEnd
	_SQLite_QueryFinalize($hQuery)
	$sMenu[0][0] = $iNb
	Return $sMenu
EndFunc


Func DBScriptListeParam($iRefAction)
	Local $sData, $hQuery, $i, $iNb = 0, $sParam[1][$icNbParamCode + 1]
	If $iRefAction = -2 Then ; Type Auto
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnRef FROM CodeEntete WHERE CEnType='A';", $sData) = $SQLITE_OK Then
			$iRefAction = $sData[0]
		Else
			Return $sParam
		EndIf
	EndIf
	_SQlite_Query($hDbPrp, "SELECT CDeType, CDeParam1, CDeParam2, CDeParam3, CDeParam4, CDeParam5 FROM CodeDetail WHERE CDeRefEntete=" & $iRefAction & " ORDER BY CDeOrdre;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		$iNb += 1
		ReDim $sParam[$iNb + 1][$icNbParamCode + 1]
		For $i = 0 To $icNbParamCode
			$sParam[$iNb][$i] = $sData[$i]
		Next
	WEnd
	_SQLite_QueryFinalize($hQuery)
	$sParam[0][0] = $iNb
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnTitreCode, CEnTpsMaxExe FROM CodeEntete WHERE CEnRef=" & $iRefAction & ";", $sData) = $SQLITE_OK Then
		$sParam[0][1] = $sData[0]
		$sParam[0][2] = $sData[1]
	EndIf
	Return $sParam
EndFunc


; Liste des touches Hotkey des scrpitings et des textes
Func DbListeHotKey()
	Local $sData, $hQuery, $iNb = 0, $sListe[1][3], $bTrop = False
	; Les HotKey des scriptings
	_SQlite_Query($hDbPrp, "SELECT CEnToucheActivation, CEnRef, CEnType FROM CodeEntete WHERE CEnToucheActivation <> '' AND CEnActif=1 ORDER BY CEnType, CEnOrdre;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		$iNb += 1
		If $iNb > $icMaxHotKey Then
			MsgBox(4112, $scMsgErreur, "Vous avez dfini plus de " & $icMaxHotKey & " raccourcis")
			$bTrop = True
			$iNb -= 1
			ExitLoop
		EndIf
		ReDim $sListe[$iNb + 1][3]
		$sListe[$iNb][0] = $sData[0]
		$sListe[$iNb][1] = $sData[1]
		$sListe[$iNb][2] = $sData[2]
	WEnd
	_SQLite_QueryFinalize($hQuery)
	; Les HotKey des textes
	If Not $bTrop Then
		_SQlite_Query($hDbPrp, "SELECT PrpPlus, ROWID FROM Texte WHERE PrpPlus LIKE '%|HKy=%' ORDER BY PrpEstFavoris DESC, PrpDateClassement DESC;", $hQuery)
		While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
			$iNb += 1
			If $iNb > $icMaxHotKey Then
				MsgBox(4112, $scMsgErreur, "Vous avez dfini plus de " & $icMaxHotKey & " raccourcis")
				$iNb -= 1
				ExitLoop
			EndIf
			ReDim $sListe[$iNb + 1][3]
			$sListe[$iNb][0] = _LireValParamPlus($sData[0], "HKy", "")
			$sListe[$iNb][1] = $sData[1]
			$sListe[$iNb][2] = "Txt"
		WEnd
		_SQLite_QueryFinalize($hQuery)
	EndIf
	; Fin
	$sListe[0][0] = $iNb
	Return $sListe
EndFunc


Func DbAjoutHistoSuppr($sType, $sDateCreation, $iRefSynchro)
	Return _SQLite_Exec($hDbPrp, "INSERT INTO HistoSuppression (HspDateSuppresssion, HspType, HspRefSynchro, HspDateCreation) VALUES ('" & _
										_DateHeureJour(3) & "', '" & $sType & "', '" & $iRefSynchro & "', '" & $sDateCreation & "');") = $SQLITE_OK
EndFunc


Func DbSupprimerParam()
	_SQLite_Exec($hDbPrp, "DELETE FROM Parametre WHERE PrmCle LIKE 'ParamB-%';")
	_SQLite_Exec($hDbPrp, "DELETE FROM Parametre WHERE PrmCle LIKE 'ParamN-%';")
	_SQLite_Exec($hDbPrp, "DELETE FROM Parametre WHERE PrmCle LIKE 'ParamT-%';")
EndFunc


Func DbScriptListe($sType)
	Local $sData, $hQuery, $iNb = 0, $sList[1][3]
	_SQlite_Query($hDbPrp, "SELECT CEnTitreCode, CEnRef, CEnOrdre FROM CodeEntete WHERE CEnType='" & $sType & "' ORDER BY CEnOrdre;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		$iNb += 1
		ReDim $sList[$iNb + 1][3]
		$sList[$iNb][0] = $sData[0]
		$sList[$iNb][1] = $sData[1]
		$sList[$iNb][2] = $sData[2]
	WEnd
	_SQLite_QueryFinalize($hQuery)
	$sList[0][0] = $iNb
	Return $sList
EndFunc


Func DbScriptDetailEntete($iRefAction)
	Local $sData
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnTitreCode, CEnTitreMenu, CEnCode, CEnToucheActivation, CEnActif, CEnTpsMaxExe FROM CodeEntete WHERE CEnRef=" & $iRefAction & ";", $sData) <> $SQLITE_OK Then
		Dim $sData[6]
		$sData[4] = 0
	EndIf
	Return $sData
EndFunc


Func DbScriptMAJOrdre($iRefAction, $dOrdreNew)
	Return (_SQLite_Exec($hDbPrp, "UPDATE CodeEntete SET CEnOrdre='" & Number($dOrdreNew) & "' WHERE CEnRef='" & $iRefAction & "';") = $SQLITE_OK)
EndFunc


Func DbScriptMAJEntete($iRefAction, $sCEnTitreCode, $sCEnTitreMenu, $sCEnCode, $sCEnToucheActivation, $iCEnActif, $iCEnTpsMaxExe)
	Return (_SQLite_Exec($hDbPrp, "UPDATE CodeEntete SET CEnTitreCode='" & _Quote($sCEnTitreCode) & "', CEnTitreMenu='" & _Quote($sCEnTitreMenu) & "', CEnCode='" & _
				_Quote($sCEnCode) & "', CEnToucheActivation='" & $sCEnToucheActivation & "', CEnActif=" & $iCEnActif & ", CEnTpsMaxExe=" & $iCEnTpsMaxExe & _
				", CEnDateModification='" & _DateHeureJour(3) & "' WHERE CEnRef=" & $iRefAction & ";") = $SQLITE_OK)
EndFunc


Func DbScriptCreerEntete($sCEnType, $dCEnOrdre, $sCEnTitreCode, $sCEnTitreMenu, $sCEnCode, $sCEnToucheActivation, $iCEnActif, $iCEnTpsMaxExe)
	Local $sData
	If _SQLite_Exec($hDbPrp, "INSERT INTO CodeEntete (CEnType, CEnOrdre, CEnTitreCode, CEnTitreMenu, CEnCode, CEnToucheActivation, CEnActif, CEnTpsMaxExe, CEnDateCreation) VALUES('" & _
				$sCEnType & "', " & $dCEnOrdre & ", '" & _Quote($sCEnTitreCode) & "', '" & _Quote($sCEnTitreMenu) & "', '" & _Quote($sCEnCode) & "', '" & _
				$sCEnToucheActivation & "', " & $iCEnActif & "," & $iCEnTpsMaxExe & ", '" & _DateHeureJour(3) & "');") = $SQLITE_OK Then
		; Retrouver le n CDeRefEntete
		If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnRef FROM CodeEntete WHERE CEnType='" & $sCEnType & "' AND CEnOrdre=" & $dCEnOrdre & ";", $sData) = $SQLITE_OK Then
			Return $sData[0]
		Else
			Return -1
		EndIf
	Else
		Return -1
	EndIf
EndFunc


Func DbScriptSupprimer($iRefAction, $sType, $bSynchronisation)
	Local $sData, $b = False
	; Retrouver la date de cration
	If _SQLite_QuerySingleRow($hDbPrp, "SELECT CEnDateCreation FROM CodeEntete WHERE CEnType='" & $sType & "' AND CEnRef='" & $iRefAction & "';", $sData) <> $SQLITE_OK Then
		Return False
	EndIf
	; Supprimer
	If _SQLite_Exec($hDbPrp, "DELETE FROM CodeEntete WHERE CEnRef='" & $iRefAction & "';") = $SQLITE_OK Then
		_SQLite_Exec($hDbPrp, "DELETE FROM CodeDetail WHERE CDeRefEntete='" & $iRefAction & "';")
		If $bSynchronisation Then DbAjoutHistoSuppr("S" & $sType, $sData[0], 0)
		$b = True
	EndIf
	Return $b
EndFunc


Func DbScriptDetailEnregistrer($iCDeRefEntete, $sCDeType, $sParamScript)
	Local $i
	; Suppression des ventuelles lignes de code
	DbScriptDetailSupprimer($iCDeRefEntete)
	; Cration des nouvelles lignes
	For $i = 1 To $sParamScript[0][0]
		_SQLite_Exec($hDbPrp, "INSERT INTO CodeDetail (CDeRefEntete, CDeOrdre, CDeType, CDeParam1, CDeParam2, CDeParam3, CDeParam4, CDeParam5) VALUES(" & _
								$iCDeRefEntete & ", " & $i & ", '" & $sParamScript[$i][0] & "', '" & _Quote( $sParamScript[$i][1]) & "', '" & _Quote( $sParamScript[$i][2]) & _
								"', '" & _Quote( $sParamScript[$i][3]) & "', '" & _Quote( $sParamScript[$i][4]) & "', '" & _Quote( $sParamScript[$i][5]) & "');")
	Next
EndFunc


Func DbScriptDetailSupprimer($iCDeRefEntete)
	_SQLite_Exec($hDbPrp, "DELETE FROM CodeDetail WHERE CDeRefEntete='" & $iCDeRefEntete & "';")
EndFunc


Func DbMajProchaineRelanceSynchro()
	Local $sProchaineSynchro = _AjouterDate(_DateHeureJour(3), DbParamLireNum("SynchroStepRelance", 15) * 60 * 1000)
	DbParamMAJTexte("SynchroProchaine", $sProchaineSynchro)
	Return $sProchaineSynchro
EndFunc


Func DbVacuum($Form, $bMessage = True)
	Local $sTaille = _TailleFichier($sFicDBComplet, 1)
	If $sTaille = -1 Then
		If $bMessage Then MsgBox(4144, $scMsgErreur, "Taille de la base non accessible !", 0, $Form)
	Else
		GUISetCursor(15, 1, $Form) ; Curseur WAIT
		If _SQLite_Exec($hDbPrp, "Vacuum") = $SQLITE_OK Then
			GUISetCursor(2) ; Curseur Classique
			If $bMessage Then MsgBox(4160, $scMsgInfo, "Le compactage est fait" & @CRLF & "Taille avant : " & $sTaille & @CRLF & "Taille aprs : " & _TailleFichier($sFicDBComplet, 1), 0, $Form)
		Else
			GUISetCursor(2) ; Curseur Classique
			If $bMessage Then MsgBox(4144, $scMsgErreur, "Le compactage a rencontr une erreur !", 0, $Form)
		EndIf
	EndIf
EndFunc

