#cs -----------------------------------------------------------------------------------------------

	Module d'Excution des Scripts programmes par l'utilisateur de ClipSpirit
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Octobre 2010 - Mars 2011

	Liste des fonctions
	-------------------
	_ExecScript($sListParam, ByRef $sTitre, ByRef $sTexte, ByRef $sCommentaire, ByRef $sCouleur, $sProvenance, $sMsgErreur, $Form, ByRef $bMajClipBoard, $sFicDebug = "", $sTexteScript = "", $sNomScript = "")

#ce -----------------------------------------------------------------------------------------------

#include-once
#include <Array.au3>
#include <ClipBoard.au3>
#include <Math.au3>
#include <Misc.au3>

AutoItSetOption("MustDeclareVars", 1)
; Variables rserves pour les scripts
Global $_Titre, $_Texte, $_Commentaire, $_Couleur, $_Provenance, $_Extended
Global $__a, $__b, $__c, $__d, $__e, $__f, $__g, $__h, $__i, $__j, $__k, $__l, $__m, $__n, $__o, $__p, $__q, $__r, $__s, $__t, $__u, $__v, $__w, $__x, $__y, $__z
Global $_Temp
; Pile des Next
Global $iNbParamForNext
Global $iParamForNext[1][6] ; [1]=Valeur utilise (*), [2]=Le TO, [3]=Step, [4]=Ligne For, [5]=Ligne Next
							; (*) [1] : 1=a, 26=27 et est mis  0 en dehors de la boucle


;--------------------------------------------------------------------------------------------------
; Fonction Exctutant un Script
;
; IN  $sListParam	 :  $sListParam[0][0] = Nb de lignes de code
;						$sListParam[0][1] = Titre du code (pas le titre du menu)
;						$sListParam[0][2] = Temps max (en secondes) laiss  l'excution du script avant de l'arrter
;						$sListParam[1][0] = Type de la ligne 1
;						$sListParam[1][1] = Param1 de la ligne 1
;						$sListParam[1][2] = Param2 de la ligne 1
;						...
;						$sListParam[2][1] = Param1 de la ligne 2
;						...
;	  $sTitre		 : La Titre de l'item
;	  $sTexte		 : Le Texte de l'item
;	  $sCommentaire	 : Le Commentaire de l'item
;	  $sCouleur		 : Couleur au format Hexa
;	  $sProvenance	 : La Provenance de l'item (en lecture seule)
;	  $sMsgErreur    : Titre des messages d'erreur
;	  $Form			 : Form appelante
;	  $bMajClipBoard : Flag de mise  jour du Clipboard
;	  $sFicDebug	 : ""=Pas de debug, "Nom Fichier"=Nom complet du fichier de debug
;	  $sTexteScript	 : En mode debug, pour le mettre dans le fichier (si ="" on ne fait rien)
;	  $sNomScript	 : Nom du script
;
; OUT Retour Func	 : -1 = Une erreur s'est produite
;					    0 = Pas de modification des entrants
;	   					1 = OK et modification d'au moins un entrant
;	  $sTitre		 : La Titre de l'item mis  jour
;	  $sTexte		 : Le Texte de l'item mis  jour
;	  $sCommentaire	 : Le Commentaire de l'item mis  jour
;--------------------------------------------------------------------------------------------------
Func _ExecScript($sListParam, ByRef $sTitre, ByRef $sTexte, ByRef $sCommentaire, ByRef $sCouleur, $sProvenance, $sMsgErreur, $Form, ByRef $bMajClipBoard, $sFicDebug = "", $sTexteScript = "", $sNomScript = "")
	Local $iNumLigne = 1, $i, $iRetour, $iNbInstruction = 0, $hTrace = 0, $bFinNormale = False
	Local $s, $sLigneTexteScript = StringSplit($sTexteScript, @CR)
	Local $iTimeBegin = TimerInit()
	Local Const $icLongMaxTitre = 50 ; Constante venant de ClipSpirit.au3
	$iNbParamForNext = 0 ; Pas de boucle For Next en cours
	; Affecter les variables d'environnement
	$_Titre = $sTitre
	$_Texte = $sTexte
	$_Commentaire = $sCommentaire
	$_Couleur = $sCouleur
	$_Provenance = $sProvenance
	; RAZ des variables des utilisateurs
	_RazVariablesUser()
	; Mode debug ?
	If $sFicDebug <> "" Then
		$hTrace = FileOpen($sFicDebug, 10) ; 10= 2:Erase + 8=Create Dir
		If $hTrace = -1 Then
			$hTrace = 0
		ElseIf $sTexteScript <> "" Then
			If $sNomScript <> "" Then
				FileWriteLine($hTrace, "Debug de " & $sNomScript & " le " & @MDAY & "/" & @MON & "/" & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC)
			Else
				FileWriteLine($hTrace, "Debug du " & @MDAY & "/" & @MON & "/" & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC)
			EndIf
			FileWriteLine($hTrace, @CRLF)
			FileWriteLine($hTrace, "Lignes du Script")
			FileWriteLine($hTrace, "================")
			For $i = 1 To $sLigneTexteScript[0]
				FileWriteLine($hTrace, StringRight("0000" & $i, 5) & " : " & StringReplace($sLigneTexteScript[$i], @LF, ""))
			Next
			; ligne supplmentaire pour la cohrence du dialogue des traces ("Passage  la ligne XXX" XXX tant aprs la dernire ligne)
			FileWriteLine($hTrace, StringRight("0000" & ($sLigneTexteScript[0] +1), 5) & " :")
			FileWriteLine($hTrace, @CRLF)
			FileWriteLine($hTrace, "Activit trace")
			FileWriteLine($hTrace, "================")
		EndIf
	EndIf
	;
	While $iNumLigne <= $sListParam[0][0]
		If ($sListParam[$iNumLigne][0] <> "NA") And ($sListParam[$iNumLigne][0] <> "X") Then $iNbInstruction +=1
		$iRetour = _ExecLigne($sListParam, $iNumLigne, $sMsgErreur, $Form, $bMajClipBoard, $hTrace)
		Switch $iRetour
			Case - 1
				ExitLoop
			Case 0
				$bFinNormale = True
				If ($sTitre = $_Titre) And ($sTexte = $_Texte) And ($sCommentaire = $_Commentaire) And ($sCouleur = $_Couleur) Then
					$iRetour = 0
				Else
					$iRetour = 1
				EndIf
				ExitLoop
			Case Else
				$iNumLigne = $iRetour
		EndSwitch
		If ($sListParam[0][2] > 0) And (TimerDiff($iTimeBegin) > ($sListParam[0][2] * 1000)) Then ExitLoop
	WEnd
	If $bFinNormale Then
		$sTitre = $_Titre
		$sTexte = $_Texte
		If $sTitre = "" Then $sTitre = TitreParDefautExe($sTexte)
		$sTitre = StringLeft($sTitre, $icLongMaxTitre)
		$sCommentaire = $_Commentaire
		$sCouleur = $_Couleur
		If $hTrace > 0 Then _ExecDebug("=== Fin Normale du Script aprs " & $iNbInstruction & " instructions droules en " & Ceiling(TimerDiff($iTimeBegin)) & " millisecondes ===", 0, $hTrace)
	ElseIf ($sListParam[0][2] > 0) And (TimerDiff($iTimeBegin) > ($sListParam[0][2] * 1000)) Then
		$sTitre = $_Titre
		$sTexte = $_Texte
		$sCommentaire = $_Commentaire
		$sCouleur = $_Couleur
		$s = "Arrt du traitement car le temps d'excution  dpass " & ($sListParam[0][2]) & " secondes"
		If $hTrace <> 0 Then _ExecDebug(" !!!!! " & $s & " !!!!!", 0, $hTrace, 1)
		MsgBox(4144, $sMsgErreur, $s, 0, $Form)
	EndIf
	; Mode debug
	If $hTrace <> 0 Then FileClose($hTrace)
	Return $iRetour
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction Excutant une ligne de code
;
; IN  $sListParam	 : Tableau des paramtres de toutes les lignes
; 	  $iLigneExec	 : La ligne  excuter (1  ...)
;	  $sMsgErreur    : Titre des messages d'erreur
;	  $Form			 : Form appelante
;	  $bMajClipBoard : Flag de mise  jour du Clipboard
;	  $hTrace		 : 0 = Pas de debug, >0 = Handle du fichier de debug
;
; OUT -1 		     : Erreur d'excution
;	   0 		     : Fin normale de l'excution de tout le code
;	   1 ... x       : Prochain n de ligne  excuter
;--------------------------------------------------------------------------------------------------
Func _ExecLigne($sListParam, $iLigneExec, $sMsgErreur, $Form, ByRef $bMajClipBoard, $hTrace)
	Local $vExe, $i, $iVarFor, $s1, $s2, $sDebug, $iRetour = -1
	; Traitement par Type
	Switch $sListParam[$iLigneExec][0]
		Case "NA" ; Ligne de commentaire ou vide
			; pas de mode trace dans ce cas
			$iRetour = $iLigneExec +1
		Case "A" ; Affectation
			$vExe = Execute($sListParam[$iLigneExec][2])
			$_Extended = @extended
			If @error = 0 Then
				If Assign($sListParam[$iLigneExec][1], $vExe, 4) = 1 Then
					If $hTrace > 0 Then _ExecDebug("L'affectation a t excute : " & $sListParam[$iLigneExec][1] & " = " & _ExecString($vExe), $iLigneExec, $hTrace)
					$iRetour = $iLigneExec +1
				Else
					If $hTrace > 0 Then _ExecDebug("L'affectation a chou : " & $sListParam[$iLigneExec][1] & " = " & _ExecString($vExe), $iLigneExec, $hTrace, 1)
				EndIf
			Else
				If $hTrace > 0 Then _ExecDebug("L'excution de l'affectation a chou : " & $sListParam[$iLigneExec][2], $iLigneExec, $hTrace, 1)
			EndIf
		Case "IT" ; If .. Then .. (mono ligne)
			$vExe = Execute($sListParam[$iLigneExec][1])
			If @error = 0 Then
				If $vExe Then
					$iRetour = _ExecAffectionOuProcedure($sListParam[$iLigneExec][2], $sListParam[$iLigneExec][3], $iLigneExec, $bMajClipBoard, $sDebug)
					If $hTrace > 0 Then
						If StringLeft($sListParam[$iLigneExec][2], 1) = "_" Then
							_ExecDebug("L'affection a t excute car la condition du If ... Then est vraie : " & $sListParam[$iLigneExec][2] & " = " & _
											_ExecString($sListParam[$iLigneExec][3]), $iLigneExec, $hTrace)
						Else
							_ExecDebug("L'instruction a t excute car la condition du If ... Then est vraie : " & $sListParam[$iLigneExec][2] & $sDebug, $iLigneExec, $hTrace)
						EndIf
					EndIf
				Else
					$iRetour = $iLigneExec +1
					If $hTrace > 0 Then _ExecDebug("Passage  la ligne suivante car la condition du If ... Then est fausse : " & $sListParam[$iLigneExec][1], $iLigneExec, $hTrace)
				EndIf
			Else
				If $hTrace > 0 Then _ExecDebug("La condition du If ... Then a chou : " & $sListParam[$iLigneExec][1], $iLigneExec, $hTrace, 1)
			EndIf
		Case "ITE" ; If .. Then .. Else .. (mono ligne)
			$vExe = Execute($sListParam[$iLigneExec][1])
			If @error = 0 Then
				$i = 2
				If $vExe Then $i = 0
				$iRetour = _ExecAffectionOuProcedure($sListParam[$iLigneExec][2 + $i], $sListParam[$iLigneExec][3 + $i], $iLigneExec, $bMajClipBoard, $sDebug)
				If $hTrace > 0 Then
					If $i = 0 Then
						$s1 = "(premire partie)"
						$s2 = "vraie"
					Else
						$s1 = "(seconde partie)"
						$s2 = "fause"
					EndIf
					If StringLeft($sListParam[$iLigneExec][2 + $i], 1) = "_" Then
						_ExecDebug("La condition du If ... Then est " & $s2 & " et donc l'affectation " & $s1 & " a t excute : " & $sListParam[$iLigneExec][2 + $i] & _
														" = " & _ExecString($sListParam[$iLigneExec][3 + $i]), $iLigneExec, $hTrace)
					Else
						_ExecDebug("La condition du If ... Then est " & $s2 & " et donc l'instruction " & $s1 & " a t excute : " & $sListParam[$iLigneExec][2 + $i] & _
														$sDebug, $iLigneExec, $hTrace)
					EndIf
				EndIf
			Else
				If $hTrace > 0 Then _ExecDebug("La condition du If ... Then a chou : " & $sListParam[$iLigneExec][1], $iLigneExec, $hTrace, 1)
			EndIf
		Case "ITM"; IF de If .. Then .. Else .. EndIf (multi lignes)
			$vExe = Execute($sListParam[$iLigneExec][1])
			If @error = 0 Then
				If $vExe Then
					If $hTrace > 0 Then _ExecDebug("Passage  la ligne suivante car la condition du If ... Then est vraie : " & $sListParam[$iLigneExec][1], $iLigneExec, $hTrace)
					$iRetour = $iLigneExec +1
				Else
					If Number($sListParam[$iLigneExec][2]) > $iLigneExec Then
						If $hTrace > 0 Then _ExecDebug("Passage  la ligne " & ($sListParam[$iLigneExec][2] +1) & " (aprs le 'Else') car la condition du If ... Then est fausse : " & $sListParam[$iLigneExec][1], $iLigneExec, $hTrace)
						$iRetour = $sListParam[$iLigneExec][2] +1 ; Ligne aprs le Else
					Else
						If $hTrace > 0 Then _ExecDebug("Passage  la ligne " & ($sListParam[$iLigneExec][3] +1) & " (aprs le 'EndIf') car la condition du If ... Then est fausse : " & $sListParam[$iLigneExec][1], $iLigneExec, $hTrace)
						$iRetour = $sListParam[$iLigneExec][3] +1 ; Ligne aprs le EndIf
					EndIf
				EndIf
			EndIf
		Case "ITME"; Else de If .. Then .. Else .. EndIf (multi lignes)
			If $hTrace > 0 Then _ExecDebug("Passage  la ligne " & ($sListParam[$iLigneExec][1] +1) & " (aprs le 'EndIf') car le 'Else' est atteint", $iLigneExec, $hTrace)
			$iRetour = $sListParam[$iLigneExec][1] +1; Ligne aprs le EndIf
		Case "ITMX"; EndIf de If .. Then .. Else .. EndIf (multi lignes)
			If $hTrace > 0 Then _ExecDebug("Passage  la ligne " & ($iLigneExec +1) & " (aprs le 'EndIf')", $iLigneExec, $hTrace)
			$iRetour = $iLigneExec +1
		Case "For" ; For de For .. To .. Step .. Next
			$iNbParamForNext +=1
			ReDim $iParamForNext[$iNbParamForNext + 1][6]
			$iParamForNext[$iNbParamForNext][1] = $sListParam[$iLigneExec][1] ; Variable __a  __z (sans le $)
			_ExecAffectionOuProcedure($iParamForNext[$iNbParamForNext][1], $sListParam[$iLigneExec][2], $iLigneExec, $bMajClipBoard, $sDebug) ; Affectation
			_ExecAffectionOuProcedure("_Temp", $sListParam[$iLigneExec][3], $iLigneExec, $bMajClipBoard, $sDebug) ; Le TO
			$iParamForNext[$iNbParamForNext][2] = $_Temp ; Le TO
			_ExecAffectionOuProcedure("_Temp", $sListParam[$iLigneExec][4], $iLigneExec, $bMajClipBoard, $sDebug) ; Step
			$iParamForNext[$iNbParamForNext][3] = $_Temp ; Step
			$iParamForNext[$iNbParamForNext][4] = $iLigneExec ; Ligne For
			$iParamForNext[$iNbParamForNext][5] = $sListParam[$iLigneExec][5] ; Ligne Next
			; Le For Next est-il  faire ?
			$iVarFor = Execute("$" & $iParamForNext[$iNbParamForNext][1])
			If Number($iParamForNext[$iNbParamForNext][3]) > 0 Then
				If $iVarFor > Number($iParamForNext[$iNbParamForNext][2]) Then
					$s1 = "suprieur"
					$iParamForNext[$iNbParamForNext][1] = ""
				EndIf
			Else
				If $iVarFor < Number($iParamForNext[$iNbParamForNext][2]) Then
					$s1 = "infrieur"
					$iParamForNext[$iNbParamForNext][1] = ""
				EndIf
			EndIf
			If $iParamForNext[$iNbParamForNext][1] = "" Then
				If $hTrace > 0 Then _ExecDebug("Le 'For ... Next' est saut car %" & StringRight($sListParam[$iLigneExec][1], 1) & "% = " & $iVarFor & " et est " & _
													$s1 & "  " & $iParamForNext[$iNbParamForNext][2], $iLigneExec, $hTrace)
				$iRetour = Number($iParamForNext[$iNbParamForNext][5]) +1
				$iNbParamForNext -=1  ; on dpile
				ReDim $iParamForNext[$iNbParamForNext + 1][6]
			Else
				If $hTrace > 0 Then _ExecDebug("Le 'For ... Next' est initialis avec %" & StringRight($sListParam[$iLigneExec][1], 1) & "% = " & $iVarFor & _
								" pour aller jusqu' " & $iParamForNext[$iNbParamForNext][2] & " par pas de " & $iParamForNext[$iNbParamForNext][3], $iLigneExec, $hTrace)
				$iRetour = $iLigneExec +1
			EndIf
		Case "ExitLoop" ; ExitLoop de For .. To .. Step .. Next
			If $hTrace > 0 Then _ExecDebug("Le 'ExitLoop' fait pass  la ligne " & $iParamForNext[$iNbParamForNext][5] +1, $iLigneExec, $hTrace)
			$iRetour = Number($iParamForNext[$iNbParamForNext][5]) +1 ; On sort de la boucle
			$iNbParamForNext -=1 ; on dpile
			ReDim $iParamForNext[$iNbParamForNext + 1][6]
		Case "ContinueLoop" ; ContinueLoop de For .. To .. Step .. Next
			If $hTrace > 0 Then _ExecDebug("Le 'ContinueLoop' fait pass  la ligne " & $iParamForNext[$iNbParamForNext][5], $iLigneExec, $hTrace)
			$iRetour = Number($iParamForNext[$iNbParamForNext][5]) ; Ligne next
		Case "Next" ; Next de For .. To .. Step .. Next
			If $iLigneExec = $iParamForNext[$iNbParamForNext][5] Then
				$iVarFor = Execute("$" & $iParamForNext[$iNbParamForNext][1]) + Number($iParamForNext[$iNbParamForNext][3])
				Assign($iParamForNext[$iNbParamForNext][1], $iVarFor, 4)
				If Number($iParamForNext[$iNbParamForNext][3]) > 0 Then
					If $iVarFor > Number($iParamForNext[$iNbParamForNext][2]) Then $iParamForNext[$iNbParamForNext][1] = ""
				Else
					If $iVarFor < Number($iParamForNext[$iNbParamForNext][2]) Then $iParamForNext[$iNbParamForNext][1] = ""
				EndIf
				If $iParamForNext[$iNbParamForNext][1] = "" Then
					If $hTrace > 0 Then _ExecDebug("Fin de la boucle 'For ... Next'", $iLigneExec, $hTrace)
					$iRetour = $iLigneExec +1
					$iNbParamForNext -=1  ; on dpile
					ReDim $iParamForNext[$iNbParamForNext + 1][6]
				Else
					If $hTrace > 0 Then _ExecDebug("A cet tape de 'Next', %" & StringRight($iParamForNext[$iNbParamForNext][1], 1) & "% = " & $iVarFor & ", donc retour  la ligne " & ($iParamForNext[$iNbParamForNext][4] +1), $iLigneExec, $hTrace)
					$iRetour = $iParamForNext[$iNbParamForNext][4] +1
				EndIf
			EndIf
		Case "PutToClipboard" ; PutToClipboard
			If $hTrace > 0 Then _ExecDebug("Mis dans le presse-papier du texte " & StringReplace($_Texte, @CRLF, @TAB & Chr(20) & @TAB), $iLigneExec, $hTrace)
			$bMajClipBoard = True
			_ClipBoard_SetData($_Texte)
			$bMajClipBoard = False
			$iRetour = $iLigneExec +1
		Case "Exit" ; Exit
			If $hTrace > 0 Then _ExecDebug("Exit du script", $iLigneExec, $hTrace)
			$iRetour = $sListParam[$iLigneExec][1]
		Case "X" ; Fin du script
			$iRetour = 0
	EndSwitch
	; Affichage de l'erreur
	If $iRetour = -1 Then MsgBox(4144, $sMsgErreur, "Erreur dans le script " & $sListParam[0][1] & @CRLF & "Ligne = " & $iLigneExec & @CRLF  & "Type = " & $sListParam[$iLigneExec][0] & _
									@CRLF  & "Param 1 = " & $sListParam[$iLigneExec][1] & @CRLF  & "Param 2 = " & $sListParam[$iLigneExec][2] & @CRLF  & "Param 3 = " & _
									$sListParam[$iLigneExec][3] & @CRLF  & "Param 4 = " & $sListParam[$iLigneExec][4] & @CRLF  & "Param 5 = " & $sListParam[$iLigneExec][5], 0, $Form)
	; Retour
	Return $iRetour
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction excutant une affectation ou une procdure
;
; IN  $sPart1		 : Variable  affecter (commence par un _) OU le code d'un procdure
;	  $sPart2		 : Valeur  affect OU la ligne suivante ventuellement pour les procdures
; 	  $iLigneExec	 : La ligne excute
;	  $bMajClipBoard : Flag de mise  jour du Clipboard
; OUT Ligne suivante  excuter
;--------------------------------------------------------------------------------------------------
Func _ExecAffectionOuProcedure($sPart1, $sPart2, $iLigneExec, ByRef $bMajClipBoard, ByRef $sDebug)
	Local $vExe, $iRetour
	If StringLeft($sPart1, 1) = "_" Then
		$vExe = Execute($sPart2)
		$_Extended = @extended
		If @error = 0 Then
			If Assign($sPart1, $vExe, 4) = 1 Then $iRetour = $iLigneExec +1
		EndIf
	Else
		Switch $sPart1
			Case "ContinueLoop"
				$sDebug = " fait pass  la ligne " & Number($sPart2)
				$iRetour = Number($sPart2)
			Case "ExitLoop"
				$sDebug = " fait pass  la ligne " & (Number($sPart2) +1)
				$iRetour = Number($sPart2) +1
			Case "PutToClipboard"
				$sDebug = " Mis dans le presse-papier le texte " & StringReplace($_Texte, @CRLF, @TAB & Chr(20) & @TAB)
				$bMajClipBoard = True
				_ClipBoard_SetData($_Texte)
				$bMajClipBoard = False
				$iRetour = $iLigneExec +1
			Case "Exit"
				$sDebug = " fait pass  la ligne " & Number($sPart2)
				$iRetour = Number($sPart2)
			Case Else
				$sDebug = " !!! Instruction non reconnue !!! Passage  la ligne " & ($iLigneExec +1)
				$iRetour = $iLigneExec +1
		EndSwitch
	EndIf
	Return $iRetour
EndFunc


Func _ExecDebug($sTexteDebug, $iLigne, $hTrace, $iErr = 0)
	Local $s = "", $i
	If $iErr = 1 Then $s = "ERREUR - "
	; Replace $_Titre, $_Texte, $_Commentaire, $_Couleur, $_Provenance, $_Extended, $_a ... $_z
	$sTexteDebug = StringReplace($sTexteDebug, "$_Titre", "%Titre%")
	$sTexteDebug = StringReplace($sTexteDebug, "_Titre", "%Titre%")
	$sTexteDebug = StringReplace($sTexteDebug, "$_Texte", "%Texte%")
	$sTexteDebug = StringReplace($sTexteDebug, "_Texte", "%Texte%")
	$sTexteDebug = StringReplace($sTexteDebug, "$_Provenance", "%Provenance%")
	$sTexteDebug = StringReplace($sTexteDebug, "_Provenance", "%Provenance%")
	$sTexteDebug = StringReplace($sTexteDebug, "$_Extended", "%Extended%")
	$sTexteDebug = StringReplace($sTexteDebug, "_Extended", "%Extended%")
	$sTexteDebug = StringReplace($sTexteDebug, "$_Commentaire", "%Commentaire%")
	$sTexteDebug = StringReplace($sTexteDebug, "_Commentaire", "%Commentaire%")
	$sTexteDebug = StringReplace($sTexteDebug, "$_Couleur", "%Couleur%")
	$sTexteDebug = StringReplace($sTexteDebug, "_Couleur", "%Couleur%")
	$sTexteDebug = StringReplace($sTexteDebug, @CRLF, @TAB & Chr(20) & @TAB)
	$sTexteDebug = StringReplace($sTexteDebug, @CR, @TAB & Chr(20) & @TAB)
	For $i = 1 To 26
		$sTexteDebug = StringReplace($sTexteDebug, "$__" & Chr($i + 96), "%" & Chr($i + 96) & "%")
		$sTexteDebug = StringReplace($sTexteDebug, "__" & Chr($i + 96), "%" & Chr($i + 96) & "%")
	Next
	If $iLigne > 0 Then $s &= StringRight("0000" & $iLigne, 5) & " : "
	FileWriteLine($hTrace, $s & $sTexteDebug)
EndFunc


Func _ExecString($sVal)
	If IsString($sVal) Then
		Return '"' & $sVal & '"'
	Else
		Return $sVal
	EndIf
EndFunc


Func _RazVariablesUser()
	$__a = ""
	$__b = ""
	$__c = ""
	$__d = ""
	$__e = ""
	$__f = ""
	$__g = ""
	$__h = ""
	$__i = ""
	$__j = ""
	$__k = ""
	$__l = ""
	$__m = ""
	$__n = ""
	$__o = ""
	$__p = ""
	$__q = ""
	$__r = ""
	$__s = ""
	$__t = ""
	$__u = ""
	$__v = ""
	$__w = ""
	$__x = ""
	$__y = ""
	$__z = ""
EndFunc


Func TitreParDefautExe($sTitre) ; Idem  TitreParDefaut dans ClipSpirit.au3
	Local Const $icLongMaxTitre = 50 ; Constante venant de ClipSpirit.au3
	$sTitre = StringReplace($sTitre, @CR, " ")
	$sTitre = StringReplace($sTitre, @LF, "")
	$sTitre = StringReplace($sTitre, @TAB, " ")
	Return StringLeft($sTitre, $icLongMaxTitre)
EndFunc
