#cs -----------------------------------------------------------------------------------------------

	Librairie Gnrale ClipSpirit
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Juin 2010 - Septembre 2011

	Liste des fonctions
	-------------------
	_EspaceBureau(ByRef $iEspaceBureau)
	_FichierExistant($sNomComplet, $bErreur = False, $sComplementMessage = "")
	_RepertoireExistant($sRepertoire, $bErreur = False, $sMess = "")
	_OterAccentCedille($sTexte)
	_ChampModifiable($hControl, $bModif)
	_CheckedUnchecked($bChecked)
	_EnableDisable($bEnable)
	_ShowHide($bShow)
	_DateHeureJour($iFormat)
	_ImageNouvelleTaille($iLargeurInitiale, $iHauteurInitiale, $iLargeurFinale, $iHauteurFinale)
	_TailleFichier($sNomComplet, $iFormat = 0)
	_InfoNomFichier($sNomComplet, $iMode = 2)
	_StringSplitInverse($sString, $sSep)
	_NumVerCourt($sVer)
	_Quote($sTexte)
	_DiffDateMilliSecondes($sDate1, $sDate2)
	_AjouterDate($sDate, $iNbMilliSecondes)
	_TransformeDate($sDate, $iFormatIn, $iFormatOut)
	_CouleurTexteEtFond($ControlID, $sCouleurFond, $sCouleurTexte = "")
	_Ressource($sNomRes)
	_ProchaineSynchro($sSynchroStep, $iSynchroStepRelance)
	_AjouterHotKeyTxt($iId, $sHotKey)
	_SupprimerHotKeyTxt($iId)
	_LireValParamPlus($sChaine, $sParam, $sDefaut)
	_EcrireValParamPlus($sChaine, $sParam, $sValeur, $sSupprSi)
	_TraceDebug($sTexte)


#ce -----------------------------------------------------------------------------------------------

#Region Include, options & dclaration ------------------------------------------------------------

#include-once
#include <Date.au3>
#include <File.au3>
#include <GUIConstantsEx.au3>
#include <Math.au3>
#include <WinAPI.au3>

AutoItSetOption("MustDeclareVars", 1)

;----- Variables Globales aux exe -----------------------------------------------------------------
; Titre de l'appli & auteur
Global Const $scAppliTitreGeneral = "ClipSpirit"
Global Const $scAuteur = "by Ahbadiane"
Global Const $scAdresseSite = "https://sites.google.com/site/ahbadianeautoit"
Global Const $scProgPrincipal = $scAppliTitreGeneral & ".exe"
Global Const $scProgPreference = $scAppliTitreGeneral & "-Pref.exe"
Global Const $scProgMAJ = $scAppliTitreGeneral & "-Maj.exe"
Global Const $scProgSynchro = $scAppliTitreGeneral & "-Synchro.exe"
Global Const $scReafFicherTApresSynchro = @ScriptDir & "\" & $scAppliTitreGeneral & "_T.flag" ; Texte
Global Const $scReafFicherFApresSynchro = @ScriptDir & "\" & $scAppliTitreGeneral & "_F.flag" ; Favoris
Global Const $scReafFicherIApresSynchro = @ScriptDir & "\" & $scAppliTitreGeneral & "_I.flag" ; Images
Global Const $scReafHotKeyApresSynchro = @ScriptDir & "\" & $scAppliTitreGeneral & "_H.flag" ; HotKey  raffecter
Global Const $scStopSynchro = @ScriptDir & "\" & $scAppliTitreGeneral & "_SynchoNext.flag" ; Changement provenant du programme de synchronisation
Global Const $scTxtNextSynchro = "Next Synchro " & $scAppliTitreGeneral & " : "
; Cle de cryptage (mot de passe FTP)
Global $scCryptCle = "Ahbadiane"
; Version
Global Const $scVersion = FileGetVersion(@ScriptDir & "\" & $scProgPrincipal)
; Messages
Global Const $scMsgErreur = "Erreur " & $scAppliTitreGeneral & " v" & $scVersion
Global Const $scMsgInfo = "Information " & $scAppliTitreGeneral
Global Const $scMsgConfirm = "Confirmation " & $scAppliTitreGeneral
; Nombre de paramtres pour une ligne de script
Global Const $icNbParamCode = 5
; Caractres de sparation des listes
Global Const $cCarSep = Chr(7)
; Max de touches Hotkey des scrpitings et des textes
Global Const $icMaxHotKey = 50
; Couleur pas dfaut
Global Const $sCouleurDef = "FFFFFF"
; Signe de Donnes Perdues
Global Const $scPerdu = Chr(7) & Chr(0) & Chr(3)
; Nombre max de caractres du Nom de la Machine utilis pour la synchonisation
Global Const $iSynchroLongeurNomMachine = 6
; Nombre de caractres maxi d'un commentaire
Global Const $icLongMaxCommentaire = 100
; Bornes de la valeur alatoire de RefSchynro
Global Const $iRefSynchroMin = 100000000000000, $iRefSynchroMax = 999999999999999
; Liste des touches Hotkey des scriptings et des textes
Global $sListeHotKey
; Constantes lies  la taille de la fentre principale
Global Const $icFenetreHauteurMin = 348
Global Const $icFenetreLargeListeMin = 260
Global Const $icFenetreLargeEditeurMin = 443
; Surface du bureau [0]=Gauche, [1]=Haut, [2]=Droit, [3]=Bas
Global $iEspaceBureau[4]
; Menu non activ
Global Const $iNoMenu = -1234567890



#EndRegion Include, options & dclaration ---------------------------------------------------------

;--------------------------------------------------------------------------------------------------
; Donne la surface de travail, donc hors barre de tche
; IN  Dim $iEspaceBureau[4]
; OUT $iEspaceBureau[0] = Position Gauche (Left)
;     $iEspaceBureau[1] = Position Haute (Top)
;     $iEspaceBureau[2] = Position Droite (Right)
;     $iEspaceBureau[3] = Position Basse (Bottom)
; Voir http://www.autoitscript.com/forum/index.php?showtopic=41576 (message N24)
;--------------------------------------------------------------------------------------------------
Func _EspaceBureau(ByRef $iEspaceBureau)
	Local $stRect = DllStructCreate("long left;long top;long right;long bottom")
	Local $iResult = _WinAPI_SystemParametersInfo(48, 0, DllStructGetPtr($stRect), 0)
	If $iResult Then
		$iEspaceBureau[0] = DllStructGetData($stRect, "left")
		$iEspaceBureau[1] = DllStructGetData($stRect, "top")
		$iEspaceBureau[2] = DllStructGetData($stRect, "right")
		$iEspaceBureau[3] = DllStructGetData($stRect, "bottom")
	Else
		$iEspaceBureau[0] = 0
		$iEspaceBureau[1] = 0
		$iEspaceBureau[2] = @DesktopWidth
		$iEspaceBureau[3] = @DesktopHeight
	EndIf
EndFunc   ;==>EspaceBureau


;--------------------------------------------------------------------------------------------------
; Fonction indiquant si le fichier existe
;
; IN  $sNomComplet		  : Nom complet du fichier : Drive (ventuellement), Rpertoire(ventuellement), nom et extension
;	  $bErreur			  : Facultatif - True si on afficher un message d'erreur
;     $sComplementMessage : Facultatif - Message complmentaire  ".. Fichier"
; OUT True si le fichier existe, False
; REM Cette fonction a t cre car FileExists() retourne True si on passe un nom de rpertoire existant
;--------------------------------------------------------------------------------------------------
Func _FichierExistant($sNomComplet, $bErreur = False, $sComplementMessage = "")
	If Not FileExists($sNomComplet) Then
		If $bErreur Then
			If $sNomComplet <> "" Then
				MsgBox(0, "Erreur G004", "Le fichier " & $sComplementMessage & @CRLF & $sNomComplet & @CRLF & "n'existe pas !")
			Else
				If $sComplementMessage <> "" Then
					MsgBox(0, "Erreur G005", "Vous n'avez pas indiqu le nom du fichier " & $sComplementMessage)
				Else
					MsgBox(0, "Erreur G006", "Vous n'avez pas indiqu de nom de fichier")
				EndIf
			EndIf
		EndIf
		Return False
	EndIf
	FileGetShortName($sNomComplet, 0)
	If @error <> 0 Then
		If $bErreur Then MsgBox(0, "Erreur G007", "Le fichier " & $sComplementMessage & " "  & @CRLF & $sNomComplet & @CRLF & "a un nom incohrent !")
		Return False
	EndIf
	If StringInStr(FileGetAttrib($sNomComplet), "D") = 0 Then
		Return True
	Else
		If $bErreur Then MsgBox(0, "Erreur G008", $sNomComplet & @CRLF & "est le nom d'un rpertoire et non d'un fichier !")
		Return False
	EndIf
EndFunc



;--------------------------------------------------------------------------------------------------
; Fonction indiquant si le rpertoire existe
;
; IN  $sRepertoire : Nom complet du rpertoire (avec ou sans \ en fin)
;     $bErreur     : Doit-on afficher un message d'erreur
;	  $sMess	   : Message supplmentaire ventuel
; OUT True si le rpertoire existe, False sinon
;--------------------------------------------------------------------------------------------------
Func _RepertoireExistant($sRepertoire, $bErreur = False, $sMess = "")
	If $sRepertoire = "" Then
		If $bErreur Then MsgBox(0, "Erreur G002", "Vous n'avez pas saisi le rpertoire " & $sMess)
		Return False
	EndIf
	If DriveStatus($sRepertoire) = "READY" Then
		Return True
	Else
		If $bErreur Then MsgBox(0, "Erreur G002", "Le rpertoire " & $sMess & @CRLF & $sRepertoire & @CRLF & "n'existe pas !")
		Return False
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction otant les accents et les c cdilles
;
; IN  $sTexte : Le texte  traiter
; OUT Les texte dbarass de ces accents et c cdilles
;--------------------------------------------------------------------------------------------------
Func _OterAccentCedille($sTexte)
	Local Const $scIniti = ""
	Local Const $scFinal = "AAAAAACEEEEIIIINOOOOOUUUUYaaaaaaceeeeiiiinooooouuuuyy"
	Local $i, $s = $sTexte
	For $i = 1 To StringLen($scIniti)
		$s = StringReplace($s, StringMid($scIniti, $i, 1), StringMid($scFinal, $i, 1), 0, 1)
	Next
	Return $s
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction permettant de passer des contrles en mode NON modifiable mais accessible
;
; IN  $hControl : ID du contrle
;	  $bModif	: True pour passer en mode modifiable, False pour passer en mode NON modifiable
; OUT /
;--------------------------------------------------------------------------------------------------
Func _ChampModifiable($hControl, $bModif)
	GUICtrlSendMsg($hControl, 0xCF, Not $bModif, 0) ; 0xCF=$EM_SETREADONLY
	If $bModif Then
		GUICtrlSetColor($hControl, 0x000000)
	Else
		GUICtrlSetColor($hControl, 0x6D6D6D)
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction traduisant True/False en $GUI_CHECKED/$GUI_UNCHECKED
;
; IN  $bChecked : True/False
; OUT $GUI_CHECKED/$GUI_UNCHECKED
;--------------------------------------------------------------------------------------------------
Func _CheckedUnchecked($bChecked)
	If $bChecked Then
		Return $GUI_CHECKED
	Else
		Return $GUI_UNCHECKED
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction traduisant True/False en $GUI_ENABLE/$GUI_DISABLE
;
; IN  $bEnable : True/False
; OUT $GUI_ENABLE/$GUI_DISABLE
;--------------------------------------------------------------------------------------------------
Func _EnableDisable($bEnable)
	If $bEnable Then
		Return $GUI_ENABLE
	Else
		Return $GUI_DISABLE
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction traduisant True/False en $GUI_SHOW/$GUI_HIDE
;
; IN  $bChecked : True/False
; OUT $GUI_SHOW/$GUI_HIDE
;--------------------------------------------------------------------------------------------------
Func _ShowHide($bShow)
	If $bShow Then
		Return $GUI_SHOW
	Else
		Return $GUI_HIDE
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction retournant une chaine au format ...
;
; IN  $iFormat : 1 = AAAA-MM-JJ_HH-MM
;                2 = AAAA-MM-JJ_HH-MM-SS
;                3 = AAAA-MM-JJ HH:MM:SS.SSS
;				 4 = JJ/MM/2010 HH:MM:SS;
;                5 = AAAAMMJJHHMMSS
;				 6 = AAAA-MM-JJ HH:MM:SS
; OUT La chaine demande
;--------------------------------------------------------------------------------------------------
Func _DateHeureJour($iFormat)
	Switch $iFormat
		Case 1
			Return @YEAR & "-" & @MON & "-" & @MDAY & "_" & @HOUR & "-" & @MIN
		Case 2
			Return @YEAR & "-" & @MON & "-" & @MDAY & "_" & @HOUR & "-" & @MIN & "-" & @SEC
		Case 3
			Return @YEAR & "-" & @MON & "-" & @MDAY & " " & @HOUR & ":" & @MIN & ":" & @SEC & "." & @MSEC
		Case 4
			Return @MDAY & "/" & @MON & "/" & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC
		Case 5
			Return @YEAR & @MON & @MDAY & @HOUR & @MIN & @SEC
		Case 6
			Return @YEAR & "-" & @MON & "-" & @MDAY & " " & @HOUR & ":" & @MIN & ":" & @SEC
	EndSwitch
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction retournant un tableau de la nouvelle taille et des espaces avant
;
; IN  $iLargeurInitiale, $iHauteurInitiale : Taille initiale d'une image
; 	  $iLargeurFinale, $iHauteurFinale     : Taille maximale finale
; OUT Le tableau donnant Largeur, Hauteur, Largeur manquante  droite, Hauteur manquante en haut
;--------------------------------------------------------------------------------------------------
Func _ImageNouvelleTaille($iLargeurInitiale, $iHauteurInitiale, $iLargeurFinale, $iHauteurFinale)
    Local $aRet[4]
    If $iLargeurInitiale <= $iLargeurFinale And $iHauteurInitiale <= $iHauteurFinale Then
        $aRet[2] = $iLargeurInitiale
        $aRet[3] = $iHauteurInitiale
        $aRet[0] = Floor(($iLargeurFinale - $aRet[2])/2)
        $aRet[1] = Floor(($iHauteurFinale - $aRet[3])/2)
    ElseIf $iLargeurInitiale > $iHauteurInitiale Then
        $aRet[2] = $iLargeurFinale
        $aRet[3] = Floor($iHauteurInitiale/($iLargeurInitiale/$iLargeurFinale))
        $aRet[0] = 0
        $aRet[1] = ($iHauteurFinale - $aRet[3])/2
    ElseIf $iLargeurInitiale < $iHauteurInitiale Then
        $aRet[2] = Floor($iLargeurInitiale/($iHauteurInitiale/$iLargeurFinale))
        $aRet[3] = $iHauteurFinale
        $aRet[0] = Floor(($iLargeurFinale - $aRet[2])/2)
        $aRet[1] = 0
    ElseIf $iLargeurInitiale = $iHauteurInitiale Then
        $aRet[2] = $iLargeurFinale
        $aRet[3] = $iHauteurFinale
        $aRet[0] = 0
        $aRet[1] = 0
    EndIf
    Return $aRet
EndFunc


Func _TailleFichier($sNomComplet, $iFormat = 0)
	Local $dTaille, $iUnite = 0, $iDec
	Local Const $scUnite[4] = ["Octets", "Ko", "Mo", "Go"]
	$dTaille = FileGetSize($sNomComplet)
	If @error = 1 Then Return - 1
	Switch $iFormat
		Case 0
			Return $dTaille
		Case 1
			While $dTaille > 1024
				$dTaille = $dTaille / 1024
				$iUnite += 1
			WEnd
			For $iDec = 0 To 3
				If stringlen(String(Round($dTaille, $iDec))) > 3 Then
					$dTaille = Round($dTaille, $iDec)
					ExitLoop
				EndIf
			Next
			Return $dTaille & " " & $scUnite[$iUnite]
	EndSwitch
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction donnant des informations sur le nom complet d'un fichier
;
; IN  $sNomComplet : Nom complet du fichier : Drive (ventuellement), Rpertoire(ventuellement), nom et extension
;	  $iMode	  =1 => Retourne le Nom du fichier sans extension
;				  =2 => Retourne le Nom du fichier avec son extension
;				  =3 => Retourne le Rpertoire avec un \ en fin (Drive & Dir)
;				  =4 => Retourne le Rpertoire sans \ en fin (Drive & Dir)
;				  =5 => Retourne uniquement l'Extension sans . (ex : txt)
;				  =6 => Retourne uniquement l'Extension avec un . (ex : .txt)
;				  =7 => Retourne tout sauf l'extension (ex : c:\temp\Monfichier)
;				  =8 => Retourne le drive sans \ (ex : D:)
;				  =9 => Retourne le drive avec \ (ex : D:\)
; OUT Voir $iMode
;--------------------------------------------------------------------------------------------------
Func _InfoNomFichier($sNomComplet, $iMode = 2)
	Local $s = ""
	Local $sDrive, $sDir, $sName, $sExt
	_PathSplit($sNomComplet, $sDrive, $sDir, $sName, $sExt)
	Switch $iMode
		Case 1 ; Nom du fichier sans extension
			$s = $sName
		Case 2 ; Nom du fichier avec ventuellement son extension
			$s = $sName & $sExt
		Case 3 ; le Rpertoire (Drive & Dir) avec un \ en fin
			$s = $sDrive & $sDir
			If ($s <> "") And (StringRight($s, 1) <> "\") Then $s &= "\"
		Case 4 ; le Rpertoire (Drive & Dir) sans \ en fin
			$s = $sDrive & $sDir
			If StringRight($s, 1) = "\" Then $s = StringLeft($s, (StringLen($s) - 1))
		Case 5 ; uniquement l'extension (sans .)
			$s = StringMid($sExt, 2)
		Case 6 ; uniquement l'extension avec un .
			$s = "." & StringMid($sExt, 2)
		Case 7 ; Retourne tout sauf l'extension
			$s = $sDrive & $sDir
			If ($s <> "") And (StringRight($s, 1) <> "\") Then $s &= "\"
			$s &= $sName
		Case 8 ; Retourne le drive sans \
			$s = $sDrive
		Case 9 ; Retourne le drive avec \
			$s = $sDrive
			If $s <> "" Then $s &= "\"
	EndSwitch
	Return $s
EndFunc   ;==>_InfoNomFichier


;--------------------------------------------------------------------------------------------------
; Fonction retournant un tableau rsulat du split d'une chaine.
; La particularit : rendre le tableau  l'inverse de la chaine (fin au dbut)
;
; IN  $sString
; 	  $sSep
; OUT Le tableau : [0] = Nb de valeur
;				   [1] ... [x] = les valeurs
;--------------------------------------------------------------------------------------------------
Func _StringSplitInverse($sString, $sSep)
	Local $i, $sTab = StringSplit($sString, $sSep)
	Local $j, $sTabRet[$sTab[0] + 1]
	$j = $sTab[0]
	$sTabRet[0] = $j
	For $i = 1 To $sTab[0]
		$sTabRet[$j] = $sTab[$i]
		$j -= 1
	Next
	Return $sTabRet
EndFunc



;--------------------------------------------------------------------------------------------------
; Fonction retournant le numro de version sur 2 positions
;
; IN  $sVer : Numro de version sur 4 positions ou moins
; OUT Numro de version sur 2 positions
;--------------------------------------------------------------------------------------------------
Func _NumVerCourt($sVer)
	Local $i = StringInStr($sVer, ".", 0, 2) -1
	If $i > 0 Then
		Return String(StringLeft($sVer, $i))
	Else
		If StringInStr($sVer, ".") = 0 Then
			Return String($sVer & ".0")
		Else
			Return String($sVer)
		EndIf
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction retournant un texte en doublant les quotes '
;
; IN  $sTexte : Le texte initial
; OUT Le texte avec les ventuelles quotes doubles (' => '')
;--------------------------------------------------------------------------------------------------
Func _Quote($sTexte)
	Return StringReplace($sTexte, "'", "''")
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction donnant la diffrence entre deux dates en millisecondes
;
; IN  $sDate1 : Premire date au format string AAAA-MM-JJ HH:MM:SS[.SSS]
;	  $sDate2 : Seconde date au format string AAAA-MM-JJ HH:MM:SS[.SSS]
; OUT La diffrence entre les deux dates en millisecondes
;	  Si l'une des dates n'a pas le format attendu, la fonction retourne -1
;--------------------------------------------------------------------------------------------------
Func _DiffDateMilliSecondes($sDate1, $sDate2)
	Local $iDiffSansMilli
	If StringLen($sDate1) = 19 Then $sDate1 &= ".000"
	If StringLen($sDate2) = 19 Then $sDate2 &= ".000"
	If (StringInStr($sDate1, ".") <> 20) Or (StringInStr($sDate2, ".") <> 20) Then Return -1
	If Not StringIsDigit(StringRight($sDate1, 3)) Or Not StringIsDigit(StringRight($sDate2, 3)) Then Return -1
	$iDiffSansMilli = _DateDiff("s", StringLeft($sDate1, 19), StringLeft($sDate2, 19)) * 1000
	If @error <> 0 Then Return -1
	$iDiffSansMilli += Number(StringRight($sDate2, 3)) - Number(StringRight($sDate1, 3))
	Return $iDiffSansMilli
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction ajoutant (ou soustraire) un nombre de millisecondes  une date
;
; IN  $sDate 			: Date initial au format string AAAA-MM-JJ HH:MM:SS[.SSS]
;	  $iNbMilliSecondes : Nombre de milliSecondes  ajouter ou soustraire  la date initiale
; OUT La nouvelle date au format string AAAA-MM-JJ HH:MM:SS.SSS
;	  Si la date n'a pas le format attendu, la fonction retourne ""
;--------------------------------------------------------------------------------------------------
Func _AjouterDate($sDate, $iNbMilliSecondes)
	Local $sDateOut, $iMilliDiff
	If StringLen($sDate) = 19 Then $sDate &= ".000"
	If (StringInStr($sDate, ".") <> 20) Or Not StringIsDigit(StringRight($sDate, 3)) Then Return ""
	$sDateOut = _DateAdd("s", Int($iNbMilliSecondes / 1000) , StringLeft($sDate, 19))
	If @error <> 0 Then Return ""
	$iMilliDiff = Round(Number(StringRight($sDate, 3)) + $iNbMilliSecondes - (Int($iNbMilliSecondes / 1000) * 1000), 0)
	If $iNbMilliSecondes >= 0 Then
		If $iMilliDiff >= 1000 Then
			$iMilliDiff -= 1000
			$sDateOut = _DateAdd("s", 1 , $sDateOut)
		EndIf
	Else
		If $iMilliDiff < 0 Then
			$iMilliDiff = 1000 + $iMilliDiff
			$sDateOut = _DateAdd("s", -1 , $sDateOut)
		EndIf
	EndIf
	Return StringReplace($sDateOut, "/", "-") & "." & StringRight("000" & $iMilliDiff, 3)
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction transformant le format d'une date
;
; IN  $sDate 	  : Date initial au format string $iFormatIn
;	  $iFormatIn  : 1 = AAAA-MM-JJ HH:MM:SS ou AAAA-MM-JJ HH:MM:SS.SSS
;					2 = AAAAMMJJHHMMSS
;	  $iFormatOut : 1 = JJ/MM/AAAA HH:MM:SS
; OUT La nouvelle date au format string $iFormatOut
;--------------------------------------------------------------------------------------------------
Func _TransformeDate($sDate, $iFormatIn, $iFormatOut)
	Local $sDateOut = $sDate
	Switch $iFormatIn
		Case 1 ; AAAA-MM-JJ HH:MM:SS
			Switch $iFormatOut
				Case 1 ; JJ/MM/AAAA HH:MM:SS
					$sDateOut = StringMid($sDate, 9, 2) & "/" & StringMid($sDate, 6, 2) & "/" & StringMid($sDate, 1, 4) & " " & StringMid($sDate, 12, 2) & ":" & StringMid($sDate, 15, 2) & ":" & StringMid($sDate, 18, 2)
			EndSwitch
		Case 2 ; AAAAMMJJHHMMSS
			Switch $iFormatOut
				Case 1 ; JJ/MM/AAAA HH:MM:SS
					$sDateOut = StringMid($sDate, 7, 2) & "/" & StringMid($sDate, 5, 2) & "/" & StringMid($sDate, 1, 4) & " " & StringMid($sDate, 9, 2) & ":" & StringMid($sDate, 11, 2) & ":" & StringMid($sDate, 13, 2)
			EndSwitch
	EndSwitch
	Return $sDateOut
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction changeant la couleur du texte en l'intensit du fond
;
; IN  $ControlID	 : ID du contrle  traiter
;	  $sCouleurFond  : Couleur de fond au format "FFFFFF"
;	  $sCouleurTexte : L'ventuelle couleur du texte au format "FFFFFF", si <> "" alors ce sera la couleur utilise
; OUT Rien
;--------------------------------------------------------------------------------------------------
Func _CouleurTexteEtFond($ControlID, $sCouleurFond, $sCouleurTexte = "")
	GUICtrlSetBkColor($ControlID, Dec($sCouleurFond))
	If $sCouleurTexte = "" Then
		If (0.299 * Dec(StringLeft($sCouleurFond, 2)) + 0.587 * Dec(StringMid($sCouleurFond, 3, 2)) + 0.114 * Dec(StringRight($sCouleurFond, 2))) < 80 Then
			GUICtrlSetColor($ControlID, 0xFFFFFF)
		Else
			GUICtrlSetColor($ControlID, 0x000000)
		EndIf
	Else
		GUICtrlSetColor($ControlID, Dec($sCouleurTexte))
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction donnant le chemin complet de la ressource.
; Si la ressource n'existe pas elle est re-cre
; La ressource est cre dans le dossier ... voir la variable $scDossier de cette fonction
;
; IN  $sNomRes : Nom de la ressource avec extension mais sans son chemin
; OUT Nom complet de la ressource (chemin, nom et extension)
; REM Les fonctions renfermant les ressources sont cres avec l'utilitaire BinCodeAutoIt
;--------------------------------------------------------------------------------------------------
Func _Ressource($sNomRes)
	Local $scDossier = @ScriptDir & "\" & $scAppliTitreGeneral & "-Ressources\"
	Local $sFuncName, $scNomcomplet = $scDossier & $sNomRes
	Local $scErr = "Erreur grave"
	Local $scFin = @CRLF & @CRLF & "L'application va s'arrter"
	If DriveStatus($scDossier) <> "READY" Then
		If DirCreate($scDossier) = 0 Then
			MsgBox(4144, $scErr, "Le dossier : " & @CRLF & $scDossier & @CRLF & " ne peut tre cr" & $scFin)
			Exit
		EndIf
	EndIf
	If Not FileExists($scNomcomplet) Then
		$sFuncName = StringReplace($sNomRes, ".", "_")
		$sFuncName = StringRegExpReplace($sFuncName, '[^\w]', '')
		If Not Execute($sFuncName & '("' & $scDossier & $sNomRes & '")') Then
			MsgBox(4144, $scErr, "Le fichier : " & $sNomRes & @CRLF & " ne peut tre re-cr dans le dossier :" & @CRLF & $scDossier & $scFin)
			Exit
		EndIf
	EndIf
	Return $scNomcomplet
EndFunc



;--------------------------------------------------------------------------------------------------
; Fonction donnant le chemin complet de la ressource
;
; IN  $sSynchroStep		   : Frquence au format HH:MM ou liste d'heure au format "|HH:MM|HH:MM|...|"
;	  $iSynchroStepRelance : Valeur en minutes de la relance en cas d'erreur
; OUT Heure-Date au format AAAA-MM-JJ HH:MM:SS.SSS ou "" si pas de relance  faire
;--------------------------------------------------------------------------------------------------
Func _ProchaineSynchro($sSynchroStep, $iSynchroStepRelance)
	Local $n, $i, $iH = 0, $iM = 0, $s, $sSplit
	If StringInStr($sSynchroStep, "|") > 0 Then
		If StringLeft($sSynchroStep, 1) = "|" Then $sSynchroStep = StringMid($sSynchroStep, 2)
		If StringRight($sSynchroStep, 1) = "|" Then $sSynchroStep = StringMid($sSynchroStep, 1, StringLen($sSynchroStep) - 1)
		$sSplit = StringSplit($sSynchroStep, "|")
		For $n = 1 To $sSplit[0]
			$i = StringInStr($sSplit[$n], ":")
			If $i > 1 Then
				$iH = StringRight("00" & StringLeft($sSplit[$n], $i - 1), 2)
			Else
				$iH = "00"
			EndIf
			$iM = StringRight("00" & StringMid($sSplit[$n], $i + 1), 2)
			$s = @YEAR & "-" & @MON & "-" & @MDAY & " " & $iH & ":" & $iM & ":00"
			If $s > _AjouterDate(_DateHeureJour(3), $iSynchroStepRelance * 60 * 1000) Then Return $s ; Heure trouve dans la journe
		Next
		$i = StringInStr($sSplit[1], ":")
		If $i > 1 Then
			$iH = StringRight("00" & StringLeft($sSplit[1], $i - 1), 2)
		Else
			$iH = "00"
		EndIf
		$iM = StringRight("00" & StringMid($sSplit[1], $i + 1), 2)
		$s = _AjouterDate(_DateHeureJour(3), 24 * 60 * 60 * 1000)
		Return StringLeft($s, 11) & $iH & ":" & $iM & ":00" ; 1 Heure demain
	ElseIf $sSynchroStep <> "" Then
		$i = StringInStr($sSynchroStep, ":")
		If $i > 1 Then $iH = StringLeft($sSynchroStep, $i - 1)
		$iM = _Max(Number(($iH * 60) + Number(StringMid($sSynchroStep, $i + 1))), Number($iSynchroStepRelance))
		Return _AjouterDate(_DateHeureJour(3), $iM * 60 * 1000)
	Else
		Return ""
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction Ajoutant un raccourci de la table mmoire ($sListeHotKey[][])
;
; IN  $iId 	   : ID de l'item
;	  $sHotKey : Valeur du raccourci (ex : !#a)
; OUT /
;--------------------------------------------------------------------------------------------------
Func _AjouterHotKeyTxt($iId, $sHotKey)
	Local $i, $b = False
	For $i = 1 To $sListeHotKey[0][0]
		If $sListeHotKey[$i][0] = "" Then
			__AjouterHotKeyTxt2($i, $iId, $sHotKey)
			$b = True
			ExitLoop
		EndIf
	Next
	If Not $b Then
		If $sListeHotKey[0][0] < $icMaxHotKey Then
			$sListeHotKey[0][0] +=1
			ReDim $sListeHotKey[$sListeHotKey[0][0] +1][3]
			__AjouterHotKeyTxt2($sListeHotKey[0][0], $iId, $sHotKey)
		Else
			MsgBox(4112, $scMsgErreur, "Vous avez dfini plus de " & $icMaxHotKey & " raccourcis" & @CRLF & "Ce dernier ne sera pris en compte")
		EndIf
	EndIf
EndFunc

Func __AjouterHotKeyTxt2($iInd, $iId, $sHotKey)
	HotKeySet($sHotKey, "ToucheHotKey" & $iInd)
	$sListeHotKey[$iInd][0] = $sHotKey
	$sListeHotKey[$iInd][1] =$iID
	$sListeHotKey[$iInd][2] = "Txt"
EndFunc

;--------------------------------------------------------------------------------------------------
; Fonction supprimant un raccourci de la table mmoire ($sListeHotKey[][])
;
; IN  $iId : ID de l'item
; OUT /
;--------------------------------------------------------------------------------------------------
Func _SupprimerHotKeyTxt($iId)
	Local $i
	For $i = 1 To $sListeHotKey[0][0]
		If $sListeHotKey[$i][1] = $iId Then
			HotKeySet($sListeHotKey[$i][0])
			$sListeHotKey[$i][0] = ""
			$sListeHotKey[$i][1] = ""
			$sListeHotKey[$i][2] = ""
			ExitLoop
		EndIf
	Next
EndFunc



;--------------------------------------------------------------------------------------------------
; Fonction permettant de lire la valeur d'un paramtre dans une chaine de N paramtres
;
; IN  $sChaine : Chaine des N Paramtres, forme tant |XYZ=12345|ABC=azerty
;	  $sParam  : Le paramtre  lire (ex XYZ)
;	  $sDefaut : Valeur par dfaut si le paramtre n'existe pas dans la chane (ex : 12345)
; OUT La valeur du paramtre $sParam
;--------------------------------------------------------------------------------------------------
Func _LireValParamPlus($sChaine, $sParam, $sDefaut)
	Local $s, $iPos = StringInStr($sChaine, $sParam & "=")
	If $iPos = 0 Then
		Return $sDefaut
	Else
		$s = StringMid($sChaine, $iPos + StringLen($sParam) +1)
		$iPos = StringInStr($s, "|")
		If $iPos = 0 Then
			Return $s
		Else
			Return StringLeft($s, $iPos -1)
		EndIf
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction permettant d'crire un paramtre dans une chaine de N paramtres
;
; IN  $sChaine  : Chaine des N Paramtres, forme tant |XYZ=12345|ABC=azerty
;	  $sParam   : Le paramtre  lire (ex XYZ)
;     $sValeur  : La valeur du paramtre $sParam (ex 67890)
;	  $sSupprSi : Si la valeur ($sValeur) gale cette valeur alors le paramtre est supprim de la chane (Ex 00000)
; OUT la nouvelle Chaine des N Paramtres sous la forme |XYZ=67890|ABC=azerty
;--------------------------------------------------------------------------------------------------
Func _EcrireValParamPlus($sChaine, $sParam, $sValeur, $sSupprSi)
	Local $s1, $s2, $iPos2, $iPos1 = StringInStr($sChaine, "|" & $sParam & "=")
	If $iPos1 = 0 Then
		If $sSupprSi = $sValeur Then
			Return $sChaine
		Else
			Return $sChaine & "|" & $sParam & "=" & $sValeur
		EndIf
	Else
		$s2 = StringMid($sChaine, $iPos1 + StringLen($sParam) +2)
		$iPos2 = StringInStr($s2, "|")
		If $iPos2 = 0 Then
			$s2 = ""
		Else
			$s2 = StringMid($s2, $iPos2)
		EndIf
		If $sSupprSi = $sValeur Then
			Return StringLeft($sChaine, $iPos1 -1) & $s2
		Else
			Return StringLeft($sChaine, $iPos1 + StringLen($sParam) +1) & $sValeur & $s2
		EndIf
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction de trace dans un fichier ayant le nom Debug.Trace
;
; IN  $sTexte : Le texte a inscrire dans le fichier
; OUT /
;--------------------------------------------------------------------------------------------------
Func _TraceDebug($sTexte)
	_FileWriteLog(@ScriptDir & "\Debug.Trace", $sTexte)
EndFunc